<?php
function pto_support_elements_metabox_callback( $post ) {
 	wp_nonce_field( 
	'support_elements_metabox', 
	'support_elements_metabox_nonce' );
	$quote_elements = get_post_meta($post->ID, 'quote_elements', true);
	$quote_details = get_post_meta($post->ID, 'project_details', true);
	if(1) {
		if(empty($quote_elements)) {
			echo '<div id="dd-container">';
			echo '<p id="no_ms_nag">' . __('You have not added any milestones to this support ticket, please do so below', 'cqpim') . '</p>';
			echo '</div>';
		} else {
			$milestones_added = true;
			$i = 0;
			$currency = get_option('currency_symbol');
			$cost_title = __('Cost', 'cqpim');
			$ordered = array();
			foreach($quote_elements as $element) {
				//If milestone is orphan then avoid it.
				if ( ! empty($element['id'] ) && ! empty( $element['weight'] ) ) {
					$weight = $element['weight'];
					$ordered[$weight] = $element;
				}
			}
			ksort($ordered);
			?>
			<div id="dd-container">
				<?php foreach($ordered as $key => $element) {
					$task_status = isset($element['status']) ? $element['status'] : '';
					$task_deadline = isset($element['deadline']) ? $element['deadline'] : '';
					if(!is_numeric($task_deadline)) {
						$str_deadline = str_replace('/','-', $task_deadline);
						$deadline_stamp = strtotime($str_deadline);
					} else {
						$deadline_stamp = $task_deadline;
					}
					$now = time();
					if($task_status != 'complete') {
						if(!empty($deadline_stamp) && $now > $deadline_stamp) {
							$milestone_status_string = '<span class="cqpim_button cqpim_small_button nolink op bg-red font-white rounded_2">' . __('Overdue', 'cqpim') . '</span>';
						} else {
							$milestone_status_string = isset($element['status']) ? $element['status'] : '';
							if(!$milestone_status_string || $milestone_status_string == 'pending') {
								$milestone_status_string = '<span class="cqpim_button cqpim_small_button nolink op bg-amber font-white rounded_2">' . __('Pending', 'cqpim') . '</span>';
							} else if($milestone_status_string == 'on_hold') {
								$milestone_status_string = '<span class="cqpim_button cqpim_small_button nolink op bg-red font-white rounded_2">' . __('On Hold', 'cqpim') . '</span>';
							}
						}
					} else {
						$milestone_status_string = '<span class="cqpim_button cqpim_small_button nolink op bg-green font-white rounded_2">' . __('Complete', 'cqpim') . '</span>';
					} ?>
					<div class="dd-milestone <?php if(!empty($milestone_toggles[$user->ID][$element['id']]) && $milestone_toggles[$user->ID][$element['id']] == 'off') { echo 'ms-toggled'; } ?>" id="milestone-<?php echo $element['id']; ?>">
						<input type="hidden" class="element_weight" name="element_weight[<?php echo $element['id']; ?>]" id="element_weight[<?php echo $element['id']; ?>]" data-msid="<?php echo $element['id']; ?>" value="<?php echo $element['weight']; ?>" />
						<div class="dd-milestone-title">
							<span class="cqpim_button cqpim_small_button font-white bg-blue-madison nolink op rounded_2" <?php if(!empty($project_colours['ms_colour'])) { ?> style="background:<?php echo $project_colours['ms_colour']; ?>"<?php } ?>><?php _e('Milestone', 'cqpim'); ?></span>  <span class="ms-title" id="ms_title_<?php echo $element['id']; ?>"><?php echo $element['title']; ?></span>
							<div class="dd-milestone-actions">
								<?php if(current_user_can('cqpim_edit_project_milestones')) { ?>
									<button class="edit-milestone cqpim_button cqpim_small_button font-white bg-amber op rounded_2 cqpim_tooltip" value="<?php echo $element['id']; ?>" title="<?php _e('Edit Milestone', 'cqpim'); ?>"><i class="fa fa-pencil-square-o" aria-hidden="true"></i></button><button class="delete_stage_conf cqpim_button cqpim_small_button font-white bg-red op rounded_2 cqpim_tooltip" data-id="<?php echo $element['id']; ?>" value="<?php echo $element['id']; ?>"  title="<?php _e('Delete Milestone', 'cqpim'); ?>"><i class="fa fa-trash" aria-hidden="true"></i></button><button class="add_task cqpim_button cqpim_small_button font-white bg-green op rounded_2 cqpim_tooltip" data-ms="<?php echo $element['id']; ?>" data-project="<?php echo $post->ID; ?>" value="<?php echo $element['id']; ?>" title="<?php _e('Add Task to Milestone', 'cqpim'); ?>"><i class="fa fa-plus" aria-hidden="true"></i></button><button class="dd-reorder cqpim_button cqpim_small_button font-white bg-blue op rounded_2 cqpim_tooltip" value="<?php echo $element['id']; ?>" title="<?php _e('Reorder Milestone', 'cqpim'); ?>"><i class="fa fa-sort" aria-hidden="true"></i></button>
								<?php } ?>
							</div>
							<div class="dd-milestone-status">
								<?php echo $milestone_status_string; ?>
							</div>
							<div class="clear"></div>
							<div class="dd-milestone-info">
								<?php if(current_user_can('cqpim_view_project_financials')) { ?>
									<?php if(!empty($element['cost'])) { ?>
										<span id="ms_cost_<?php echo $element['id']; ?>"><?php echo pto_calculate_currency($post->ID, $element['cost']); ?></span>
									<?php } ?>
								<?php } ?>
								<?php if(!empty($element['start'])) { ?>
									<i class="fa fa-circle dd-circle"></i> <strong><?php _e('Start Date:', 'cqpim'); ?></strong> <span id="ms_start_<?php echo $element['id']; ?>"><?php echo wp_date(get_option('cqpim_date_format'), $element['start']); ?></span>
								<?php } ?>
								<?php if(!empty($element['deadline'])) { ?>
									<i class="fa fa-circle dd-circle"></i> <strong><?php _e('Deadline:', 'cqpim'); ?></strong> <span id="ms_deadline_<?php echo $element['id']; ?>"><?php echo wp_date(get_option('cqpim_date_format'), $element['deadline']); ?></span>
								<?php } ?>
							</div>
							<div class="clear"></div>
						</div>
						<div class="dd-tasks" data-ms="<?php echo $element['id']; ?>">
							<?php 
							$args = array(
								'post_type' => 'cqpim_tasks',
								'posts_per_page' => -1,
								'meta_key' => 'milestone_id',
								'meta_value' => $element['id'],
								'orderby' => 'date',
								'order' => 'ASC'
							);
							$tasks = get_posts($args);
							$ordered = array();
							foreach($tasks as $task) {
								$task_details = get_post_meta($task->ID, 'task_details', true);
								$weight = isset($task_details['weight']) ? $task_details['weight'] : 0;
								if(empty($task->post_parent)) {
									$ordered[$weight] = $task;
								}
							}
							ksort($ordered);
							foreach($ordered as $task) {
								$task_details = get_post_meta($task->ID, 'task_details', true);
								$task_deadline = isset($task_details['deadline']) ? $task_details['deadline'] : '';
								$start = isset($task_details['task_start']) ? $task_details['task_start'] : '';
								$description = isset($task_details['task_description']) ? $task_details['task_description'] : '';
								$weight = isset($task_details['weight']) ? $task_details['weight'] : 0;
								$task_owner = get_post_meta($task->ID, 'owner', true);
								$task_owner_id = get_post_meta($task->ID, 'owner', true);
								$client_check = preg_replace('/[0-9]+/', '', $task_owner);
								unset($client);
								if($client_check == 'C') {
									$client = true;
								}
								if($task_owner) {
									if(!empty($client) && $client == true) {
										$id = preg_replace("/[^0-9,.]/", "", $task_owner);
										$client_object = get_user_by('id', $id);
										$task_owner = $client_object->display_name;
									} else {
										$team_details = get_post_meta($task_owner, 'team_details', true);
										$team_name = isset($team_details['team_name']) ? $team_details['team_name']: '';
										if(!empty($team_name)) {
											$task_owner = $team_name;
										}
									}
								} else {
									$task_owner = '';
								}
								$task_deadline = isset($task_details['deadline']) ? $task_details['deadline'] : '';
								$task_pc = isset($task_details['task_pc']) ? $task_details['task_pc'] : '0';
								$task_status = isset($task_details['status']) ? $task_details['status'] : '';
								$task_time = isset($task_details['task_time']) ? $task_details['task_time'] : '';
								$task_est_time = isset($task_details['task_est_time']) ? $task_details['task_est_time'] : '';
								$task_priority = isset($task_details['task_priority']) ? $task_details['task_priority'] : '';
								$time_spent_total = 0;
								$time_spent = get_post_meta($task->ID, 'task_time_spent', true);
								if(!empty($time_spent)) {
									foreach($time_spent as $time) {
										$timer = isset($time['time']) ? $time['time']: 0;
										$time_spent_total = $time_spent_total + $timer;
										$project_total_time_spent = $project_total_time_spent + $timer;
									}
								}
								if(!is_numeric($task_deadline)) {
									$str_deadline = str_replace('/','-', $task_deadline);
									$deadline_stamp = strtotime($str_deadline);
								} else {
									$deadline_stamp = $task_deadline;
								}
								$now = time();
								if($task_status != 'complete') {
									if(!empty($deadline_stamp) && $now > $deadline_stamp) {
										$task_status_string = '<span class="cqpim_button cqpim_small_button font-white bg-red rounded_2 op nolink rounded_2">' . __('OVERDUE', 'cqpim') . '</span>';
									} else {
										$task_status_string = isset($task_details['status']) ? $task_details['status'] : '';
										if(!$task_status_string || $task_status_string == 'pending') {
											$task_status_string = '<span class="cqpim_button cqpim_small_button font-white bg-amber rounded_2 op nolink rounded_2">' . __('Pending', 'cqpim') . '</span>';
										} else if($task_status_string == 'on_hold') {
											$task_status_string = '<span class="cqpim_button cqpim_small_button font-white bg-red rounded_2 op nolink rounded_2">' . __('On Hold', 'cqpim') . '</span>';
										} else if($task_status_string == 'progress') {
											$task_status_string = '<span class="cqpim_button cqpim_small_button font-white bg-amber rounded_2 op nolink rounded_2">' . __('In Progress', 'cqpim') . '</span>';
										}
									}
								} else {
									$task_status_string = '<span class="cqpim_button cqpim_small_button font-white bg-green rounded_2 op nolink rounded_2">' . __('Complete', 'cqpim') . '</span>';
								}
								unset($hide);							
								if(!empty($quote_details['hide_complete']) && $task_status == 'complete') {
									$hide = true;
								} ?>	
								<div <?php if(!empty($hide)) { ?>style="display:none"<?php } ?> class="dd-task<?php if(pto_is_task_overdue($task->ID) == 1) { ?> overdue<?php } ?>" id="task-<?php echo $task->ID; ?>">
									<input class="task_weight" type="hidden" name="task_weight_<?php echo $task->ID; ?>" id="task_weight_<?php echo $task->ID; ?>" value="<?php echo $weight; ?>" />
									<input class="task_id" type="hidden" name="task_id_<?php echo $task->ID; ?>" id="task_id_<?php echo $task->ID; ?>" value="<?php echo $task->ID; ?>" />
									<input class="task_msid" type="hidden" name="task_msid_<?php echo $task->ID; ?>" id="task_msid_<?php echo $task->ID; ?>" value="<?php echo $element['id']; ?>" />
									<span class="table-task cqpim_button cqpim_small_button font-white bg-grey-cascade op nolink rounded_2" <?php if(!empty($project_colours['task_colour'])) { ?> style="background:<?php echo $project_colours['task_colour']; ?>"<?php } ?>><?php _e('Task', 'cqpim'); ?></span> <a href="<?php echo get_edit_post_link($task->ID); ?>"><span class="ms-title" id="task_title_<?php echo $task->ID; ?>"><?php echo $task->post_title; ?></span></a>
									<?php if(current_user_can('cqpim_edit_project_milestones')) { ?>
										<div class="dd-task-actions">
											<button class="delete_task_trigger cqpim_button cqpim_small_button font-white bg-red op rounded_2 cqpim_tooltip" data-id="<?php echo $task->ID; ?>" value="<?php echo $task->ID; ?>" title="<?php _e('Delete Task', 'cqpim'); ?>"><i class="fa fa-trash" aria-hidden="true"></i></button><button class="item_complete cqpim_button cqpim_small_button font-white bg-grey-cascade op rounded_2 cqpim_tooltip" data-type="task" value="<?php echo $task->ID; ?>"title="<?php _e('Mark Task Complete', 'cqpim'); ?>"><i class="fa fa-check" aria-hidden="true"></i></button><button class="add_subtask cqpim_button cqpim_small_button font-white bg-green op rounded_2 cqpim_tooltip" data-ms="<?php echo $element['id']; ?>" data-project="<?php echo $post->ID; ?>" value="<?php echo $task->ID; ?>" title="<?php _e('Add Subtask', 'cqpim'); ?>"><i class="fa fa-plus" aria-hidden="true"></i></button><button class="dd-reorder cqpim_button cqpim_small_button font-white bg-blue op rounded_2 cqpim_tooltip" value="<?php echo $element['id']; ?>" title="<?php _e('Reorder Task', 'cqpim'); ?>"><i class="fa fa-sort" aria-hidden="true"></i></button>
										</div>
									<?php } ?>
									<div class="dd-task-status">
										<?php echo $task_status_string; ?>
									</div>
									<div class="dd-task-info">
										<?php if(!empty($start)) { ?>
											<strong><?php _e('Start Date:', 'cqpim') ?></strong> <?php echo wp_date(get_option('cqpim_date_format'), $start); ?>
										<?php } ?>
										<?php if(!empty($task_deadline)) { ?>
											<i class="fa fa-circle dd-circle"></i> <strong><?php _e('Deadline:', 'cqpim') ?></strong> <?php echo wp_date(get_option('cqpim_date_format'), $task_deadline); ?>
										<?php } ?>
										<?php if(!empty($task_owner)) { ?>
											<i class="fa fa-circle dd-circle"></i> <strong><?php _e('Assigned To:', 'cqpim') ?></strong> <?php echo $task_owner; ?>
										<?php } ?>
										<?php if(!empty($task_est_time)) { ?>
											<i class="fa fa-circle dd-circle"></i> <strong><?php _e('Est. Time:', 'cqpim') ?></strong> <?php echo $task_est_time; ?>
										<?php } ?>
										<?php if(!empty($time_spent_total)) { ?>
											<i class="fa fa-circle dd-circle"></i> <strong><?php _e('Time Spent:', 'cqpim') ?></strong> <?php echo $time_spent_total; ?>	
										<?php } ?>
									</div>
									<div class="dd-subtasks">
										<?php 
										$args = array(
											'post_type' => 'cqpim_tasks',
											'posts_per_page' => -1,
											'meta_key' => 'milestone_id',
											'meta_value' => $element['id'],
											'post_parent' => $task->ID,
											'orderby' => 'date',
											'order' => 'ASC'
										);
										$subtasks = get_posts($args);
										$ordered = array();
										foreach($subtasks as $subtask) {
											$task_details = get_post_meta($subtask->ID, 'task_details', true);
											$weight = isset($task_details['weight']) ? $task_details['weight'] : 0;
											$ordered[$weight] = $subtask;
										}
										ksort($ordered);
										if(!empty($ordered)) {
											foreach($ordered as $subtask) {
												$task_details = get_post_meta($subtask->ID, 'task_details', true);
												$task_deadline = isset($task_details['deadline']) ? $task_details['deadline'] : '';
												$start = isset($task_details['task_start']) ? $task_details['task_start'] : '';
												$description = isset($task_details['task_description']) ? $task_details['task_description'] : '';
												$weight = isset($task_details['weight']) ? $task_details['weight'] : 0;
												$task_owner = get_post_meta($subtask->ID, 'owner', true);
												$task_owner_id = get_post_meta($subtask->ID, 'owner', true);
												$client_check = preg_replace('/[0-9]+/', '', $task_owner);
												unset($client);
												if($client_check == 'C') {
													$client = true;
												}
												if($task_owner) {
													if(!empty($client) && $client == true) {
														$id = preg_replace("/[^0-9,.]/", "", $task_owner);
														$client_object = get_user_by('id', $id);
														$task_owner = $client_object->display_name;
													} else {
														$team_details = get_post_meta($task_owner, 'team_details', true);
														$team_name = isset($team_details['team_name']) ? $team_details['team_name']: '';
														if(!empty($team_name)) {
															$task_owner = $team_name;
														}
													}
												} else {
													$task_owner = '';
												}
												$task_deadline = isset($task_details['deadline']) ? $task_details['deadline'] : '';
												$task_pc = isset($task_details['task_pc']) ? $task_details['task_pc'] : '0';
												$task_status = isset($task_details['status']) ? $task_details['status'] : '';
												$task_time = isset($task_details['task_time']) ? $task_details['task_time'] : '';
												$task_est_time = isset($task_details['task_est_time']) ? $task_details['task_est_time'] : '';
												$task_priority = isset($task_details['task_priority']) ? $task_details['task_priority'] : '';
												$time_spent_total = 0;
												$time_spent = get_post_meta($subtask->ID, 'task_time_spent', true);
												if(!empty($time_spent)) {
													foreach($time_spent as $time) {
														$timer = isset($time['time']) ? $time['time']: 0;
														$time_spent_total = $time_spent_total + $timer;
														$project_total_time_spent = $project_total_time_spent + $timer;
													}
												}
												if(!is_numeric($task_deadline)) {
													$str_deadline = str_replace('/','-', $task_deadline);
													$deadline_stamp = strtotime($str_deadline);
												} else {
													$deadline_stamp = $task_deadline;
												}
												$now = time();
												if($task_status != 'complete') {
													if(!empty($deadline_stamp) && $now > $deadline_stamp) {
														$task_status_string = '<span class="cqpim_button cqpim_small_button font-white bg-red rounded_2 op nolink rounded_2">' . __('OVERDUE', 'cqpim') . '</span>';
													} else {
														$task_status_string = isset($task_details['status']) ? $task_details['status'] : '';
														if(!$task_status_string || $task_status_string == 'pending') {
															$task_status_string = '<span class="cqpim_button cqpim_small_button font-white bg-amber rounded_2 op nolink rounded_2">' . __('Pending', 'cqpim') . '</span>';
														} else if($task_status_string == 'on_hold') {
															$task_status_string = '<span class="cqpim_button cqpim_small_button font-white bg-red rounded_2 op nolink rounded_2">' . __('On Hold', 'cqpim') . '</span>';
														} else if($task_status_string == 'progress') {
															$task_status_string = '<span class="cqpim_button cqpim_small_button font-white bg-amber rounded_2 op nolink rounded_2">' . __('In Progress', 'cqpim') . '</span>';
														}
													}
												} else {
													$task_status_string = '<span class="cqpim_button cqpim_small_button font-white bg-green rounded_2 op nolink rounded_2">' . __('Complete', 'cqpim') . '</span>';
												}
												unset($hide);							
												if(!empty($quote_details['hide_complete']) && $task_status == 'complete') {
													$hide = true;
												} ?>	
												<div <?php if(!empty($hide)) { ?>style="display:none"<?php } ?> class="dd-subtask<?php if(pto_is_task_overdue($subtask->ID) == 1) { ?> overdue<?php } ?>" id="task-<?php echo $subtask->ID; ?>">
													<input class="task_weight" type="hidden" name="task_weight_<?php echo $subtask->ID; ?>" id="task_weight_<?php echo $subtask->ID; ?>" value="<?php echo $weight; ?>" />
													<input class="task_id" type="hidden" name="task_id_<?php echo $subtask->ID; ?>" id="task_id_<?php echo $subtask->ID; ?>" value="<?php echo $subtask->ID; ?>" />
													<span class="table-task cqpim_button cqpim_small_button font-white bg-grey-cascade op nolink rounded_2" <?php if(!empty($project_colours['task_colour'])) { ?> style="background:<?php echo $project_colours['task_colour']; ?>"<?php } ?>><?php _e('Subtask', 'cqpim'); ?></span> <a href="<?php echo get_edit_post_link($subtask->ID); ?>"><span class="ms-title" id="task_title_<?php echo $subtask->ID; ?>"><?php echo $subtask->post_title; ?></span></a>
													<?php if(current_user_can('publish_cqpim_quotes')) { ?>
														<div class="dd-task-actions">
															<button class="delete_subtask_trigger cqpim_button cqpim_small_button font-white bg-red op rounded_2 cqpim_tooltip" data-id="<?php echo $subtask->ID; ?>" value="<?php echo $subtask->ID; ?>" title="<?php _e('Delete Subtask', 'cqpim'); ?>"><i class="fa fa-trash" aria-hidden="true"></i></button><button class="item_complete cqpim_button cqpim_small_button font-white bg-grey-cascade op rounded_2 cqpim_tooltip" data-type="task" value="<?php echo $subtask->ID; ?>"title="<?php _e('Mark Subtask Complete', 'cqpim'); ?>"><i class="fa fa-check" aria-hidden="true"></i></button><button class="dd-reorder cqpim_button cqpim_small_button font-white bg-blue op rounded_2 cqpim_tooltip" value="<?php echo $element['id']; ?>" title="<?php _e('Reorder Subtask', 'cqpim'); ?>"><i class="fa fa-sort" aria-hidden="true"></i></button>
														</div>
													<?php } ?>
													<div class="dd-task-status">
														<?php echo $task_status_string; ?>
													</div>
													<div class="dd-task-info">
														<?php if(!empty($start)) { ?>
															<strong><?php _e('Start Date:', 'cqpim') ?></strong> <?php echo wp_date(get_option('cqpim_date_format'), $start); ?>
														<?php } ?>
														<?php if(!empty($task_deadline)) { ?>
															<i class="fa fa-circle dd-circle"></i> <strong><?php _e('Deadline:', 'cqpim') ?></strong> <?php echo wp_date(get_option('cqpim_date_format'), $task_deadline); ?>
														<?php } ?>
														<?php if(!empty($task_owner)) { ?>
															<i class="fa fa-circle dd-circle"></i> <strong><?php _e('Assigned To:', 'cqpim') ?></strong> <?php echo $task_owner; ?>
														<?php } ?>
														<?php if(!empty($task_est_time)) { ?>
															<i class="fa fa-circle dd-circle"></i> <strong><?php _e('Est. Time:', 'cqpim') ?></strong> <?php echo $task_est_time; ?>
														<?php } ?>
														<?php if(!empty($time_spent_total)) { ?>
															<i class="fa fa-circle dd-circle"></i> <strong><?php _e('Time Spent:', 'cqpim') ?></strong> <?php echo $time_spent_total; ?>	
														<?php } ?>
													</div>
													<div class="clear"></div>
												</div>
											<?php } ?>
										<?php } ?>
									</div>
								</div>
							<?php } ?>
						</div>
						<?php if(!empty($quote_details['hide_complete']) && $quote_details['hide_complete']) { ?>
							<div class="dd-task">
								<?php _e('Completed tasks are hidden. To see all tasks, click "Show Completed Tasks"', 'cqpim'); ?>
							</div>
						<?php } ?>
					</div>
				<?php } ?>
			</div>


		<?php }
	} else {
		_e('Please update this post before adding milestones', 'cqpim');
	}
	$quote_details = get_post_meta($post->ID, 'project_details', true); ?>
	
	
	
	<?php if(!empty($project_total_time_spent)) { ?>
		<div id="project_total_time" class="cqpim-alert cqpim-alert-info alert-display">
			<?php echo sprintf(__('Total Project Time: %1$s hours', 'cqpim'), $project_total_time_spent); ?>
		</div>
	<?php } ?>
	<?php $quote_details = get_post_meta($post->ID, 'project_details', true);
	if(empty($quote_details['hide_complete'])) { ?>
		<a id="toggle_all_tasks" class="mt-20 cqpim_button bg-blue font-white rounded_2 right"><?php _e('Hide Completed Tasks', 'cqpim'); ?></a> 
	<?php } else {
		if(!empty($quote_details['hide_complete']) && $quote_details['hide_complete'] == true) { ?>
			<a id="toggle_all_tasks" class="mt-20 cqpim_button bg-blue font-white rounded_2 right"><?php _e('Show Completed Tasks', 'cqpim'); ?></a> 
		<?php } else { ?>
			<a id="toggle_all_tasks" class="mt-20 cqpim_button bg-blue font-white rounded_2 right"><?php _e('Show Completed Tasks', 'cqpim'); ?></a> 
		<?php }
	} ?>

	
	

			<?php if(current_user_can('cqpim_apply_project_templates')) { ?>
				<a href="#apply-template" id="apply-template" class="mt-20 cqpim_button bg-blue font-white rounded_2 right colorbox"><?php _e('Apply Milestone Template', 'cqpim'); ?></a>
			<?php } ?>
			<a href="#add-milestone-div" id="add-milestone" class="mt-20 cqpim_button bg-blue font-white rounded_2 right colorbox"><?php _e('Add Milestone', 'cqpim'); ?></a>
			<a href="#clear-all" id="clear-all" class="mt-20 cqpim_button bg-blue font-white rounded_2 right colorbox"><?php _e('Clear All Milestones / Tasks', 'cqpim'); ?></a>
			
			<div class="clear"></div>
			
			
			<div id="apply-template-div-container" style="display:none">
				<div id="apply-template-div">
					<div style="padding:12px">
						<h3><?php _e('Apply Milestone / Task Template', 'cqpim'); ?></h3>
						<?php
						echo '<p>' . _e('Choose a template to apply Milestones and Tasks from.', 'cqpim') . '</p>';
						$args = array(
							'post_type' => 'cqpim_templates',
							'posts_per_page' => -1,
							'post_status' => 'private'
						);
						$templates = get_posts($args);
						?>
						<select id="template_choice">
							<option value=""><?php _e('Choose a template...', 'cqpim'); ?></option>
							<?php foreach($templates as $template) { ?>
								<option value="<?php echo $template->ID; ?>"><?php echo $template->post_title; ?></option>
							<?php } ?>
						</select>
						<div id="template_team_warning" style="display:none"></div>
						<br /><br />
						<button class="cancel-colorbox cqpim_button op font-white bg-red rounded_2"><?php _e('Cancel', 'cqpim'); ?></button>
						<button id="apply-template-action" class="metabox-add-button cqpim_button font-white bg-green rounded_2 right op" data-type="quote" data-hid="<?php if ( ! empty( $new_id ) ) { echo esc_attr($new_id); } ?>" data-hwe="<?php if ( ! empty( $new_weight ) ) { echo esc_attr($new_weight); } ?>" value="<?php echo $post->ID; ?>"><?php _e('Apply Template', 'cqpim'); ?></button>
						<div class="clear"></div>
						<br />
						<div id="apply-template-messages"></div>
					</div>
				</div>
			</div>
			
			<!-- Assign All Container -->
			
			<div id="assign-all-container" style="display:none">
				<div id="assign-all">
					<div style="padding:12px">
						<h3><?php _e('Assign All Tasks', 'cqpim'); ?></h3>
						<p><?php _e('Choose a Team Member that you\'d like to assign all tasks on this milestone to.', 'cqpim'); ?></p>
						<?php
						$project_contributors = get_post_meta($post->ID, 'project_contributors', true);
						if(empty($project_contributors)) {
							echo '<div class="cqpim-alert cqpim-alert-warning alert-display">' . __('You have not added any team members to this project, you\'ll need to add some in order to assign tasks to them.', 'cqpim') . '</div>';
						} else { ?>
							<select id="assign_all_assignee">
								<option value=""><?php _e('Choose...', 'cqpim'); ?></option>
								<?php foreach($project_contributors as $contrib) { 
									$team_details = get_post_meta($contrib['team_id'], 'team_details', true);
									$team_name = isset($team_details['team_name']) ? $team_details['team_name'] : '';								
									?>
									<option value="<?php echo $contrib['team_id']; ?>"><?php echo $team_name; ?></option>
								<?php } ?>
							</select>
							<br /><br />
							<input type="checkbox" id="assign_all_notify" /> <?php _e('Send notifications to the new assignee for each task.', 'cqpim'); ?>
							<br /><br />
						<?php } ?>
						<input type="hidden" id="assign_all_ms" value="" />
						<div id="assign-all-message"></div>
						<button class="cancel-colorbox cqpim_button op font-white bg-red rounded_2"><?php _e('Cancel', 'cqpim'); ?></button>
						<button class="assign-all-confirm metabox-add-button cqpim_button font-white bg-green rounded_2 right op"><?php _e('Save', 'cqpim'); ?></button>
						<div class="clear"></div>
					</div>
				</div>
			</div>			

			<!-- Clear All Colorbox -->
			
			<div id="clear-all-div-container" style="display:none">
				<div id="clear-all-div">
					<div style="padding:12px">
						<h3><?php _e('Clear All', 'cqpim'); ?></h3>
						<p><?php _e('Are you sure you want to clear all Milestones and Tasks? This cannot be undone.', 'cqpim'); ?></p>
						<br /><br />
						<button class="cancel-colorbox cqpim_button op font-white bg-red rounded_2"><?php _e('Cancel', 'cqpim'); ?></button>
						<button id="clear-all-action" class="metabox-add-button cqpim_button font-white bg-green rounded_2 right op" data-type="quote" value="<?php echo $post->ID; ?>"><?php _e('Clear All', 'cqpim'); ?></button> <div id="clear_spinner" class="ajax_spinner" style="display:none"></div>
						<div class="clear"></div>
						<br />
						<div id="clear-all-messages"></div>
					</div>
				</div>
			</div>
			
			<!-- Add Milestone Colorbox -->
			
			<div id="add-milestone-div-container" style="display:none">
				<div id="add-milestone-div">
					<div style="padding:12px">
						<h3><?php _e('Add Milestone', 'cqpim'); ?></h3>
						<div id="add_milestone_form">
							<input style="width:100%" type="text" name="quote_element_title" id="quote_element_title" placeholder="<?php _e('Milestone title, eg. \'Design Phase\'', 'cqpim'); ?>"/>
							<input style="width:100%" class="datepicker" type="text" name="quote_element_start" id="quote_element_start" placeholder="<?php _e('Start', 'cqpim'); ?>"/>
							<input style="width:100%" class="datepicker" type="text" name="quote_element_finish" id="quote_element_finish" placeholder="<?php _e('Deadline', 'cqpim'); ?>"/>
							<input style="width:100%" type="text" name="quote_element_cost" id="quote_element_cost" placeholder="<?php _e('Cost', 'cqpim'); ?>"/>
							<br /><br />
							<button class="cancel-colorbox cqpim_button op font-white bg-red rounded_2"><?php _e('Cancel', 'cqpim'); ?></button>
							<input type="submit" id="add_quote_element" class="metabox-add-button cqpim_button font-white bg-green rounded_2 right op" value="<?php _e('Add Milestone', 'cqpim'); ?>">
						</div>
					</div>
				</div>	
			</div>
			
			<!-- Edit Milestone Colorbox -->
			
			<div id="edit-milestone-container" style="display:none">
				<div id="edit-milestone" class="edit_milestone">
					<div style="padding:12px">
						<h3><?php _e('Edit Milestone', 'cqpim'); ?></h3>
						<input type="hidden" class="element_id" id="edit_milestone_id" value="" />
						<span class="label"><strong><?php _e('Title:', 'cqpim'); ?></strong></span>
						<input type="text" id="edit_milestone_title" value="" />
						<br />
						<span class="label"><strong><?php _e('Start Date:', 'cqpim'); ?></strong></span>
						<input class="datepicker" type="text" id="edit_milestone_start" value="" />
						<br />
						<span class="label"><strong><?php _e('Deadline:', 'cqpim'); ?></strong></span>
						<input class="datepicker" type="text" id="edit_milestone_end" value="" />
						<br />
						<span class="label"><strong><?php _e('Cost:', 'cqpim'); ?></strong></span>
						<input type="text" id="edit_milestone_cost" value="" />
						<br />
						<span class="label"><strong><?php _e('Finished Cost:', 'cqpim'); ?></strong></span>
						<br />
						<input type="text" id="edit_milestone_fcost" value="" />
						<br /><br />
						<span class="label"><strong><?php _e('Status:', 'cqpim'); ?></strong></span>
						<select class="status" name="edit_milestone_status" id="edit_milestone_status">
							<option value="pending"><?php _e('Pending', 'cqpim'); ?></option>
							<option value="on_hold"><?php _e('On Hold', 'cqpim'); ?></option>
							<option value="complete"><?php _e('Complete', 'cqpim'); ?></option>
						</select>
						<div class="clear"></div>
						<br />
						<button class="cancel-colorbox cqpim_button op font-white bg-red rounded_2"><?php _e('Cancel', 'cqpim'); ?></button>
						<button class="save-milestone metabox-add-button cqpim_button font-white bg-green rounded_2 right op" value="<?php echo $element['id']; ?>"><?php _e('Save', 'cqpim'); ?></button>
						<div class="clear"></div>
						<div id="edit-milestone-messages"></div>
					</div>
				</div>
			</div>
			
			<!-- Delete Milestone Colorbox -->
			
			<div id="delete-milestone-div-container" style="display:none">
				<div id="delete-milestone" class="delete-milestone-div">
					<div style="padding:12px">
						<h3><?php _e('Are you sure?', 'cqpim'); ?></h3>
						<p><?php _e('Deleting this milestone will also delete related tasks. Are you sure you want to do this?', 'cqpim'); ?></p>
						<br />
						<button class="cancel_delete_stage cqpim_button op font-white bg-red rounded_2"><?php _e('Cancel', 'cqpim'); ?></button>
						<button id="delete-milestone-button" class="delete_stage metabox-add-button cqpim_button font-white bg-green rounded_2 right op" value=""><?php _e('Delete', 'cqpim'); ?></button>
						<div class="clear"></div>
						<div id="delete-milestone-messages"></div>
					</div>
				</div>
			</div>
			
			<!-- Add Task Colorbox -->
			
			<div id="add-task-div-container" style="display:none">
				<div id="add-task-div" class="add-task-div">
					<div style="padding:12px">
						<h3><?php _e('Add Task', 'cqpim'); ?></h3>
						<input type="hidden" id="add_task_milestone_id" value="" />
						<input type="hidden" id="add_task_project_id" value="<?php echo $post->ID; ?>" />
						<input style="width:100%" type="text" id="add_task_title" placeholder="<?php _e('Task title', 'cqpim'); ?>"/><br /><br />					
						<textarea style="width:100%;height:100px" id="add_task_description" placeholder="<?php _e('Task description', 'cqpim'); ?>"></textarea><br /><br />
						<input style="width:100%"class="datepicker" type="text" id="add_task_start" placeholder="<?php _e('Start Date', 'cqpim'); ?>"/>
						<input style="width:100%"class="datepicker" type="text" id="add_task_finish" placeholder="<?php _e('Deadline', 'cqpim'); ?>"/><br /><br />
						<input style="width:100%" type="text" id="add_task_time" placeholder="<?php _e('Estimated Time (in decimal format, eg. 4.5 hours)', 'cqpim'); ?>"/>																		
						<div class="clear"></div>
						<?php
						$project_contributors = get_post_meta($post->ID, 'project_contributors', true);
						$project_contributors = $project_contributors&&is_array($project_contributors)?$project_contributors:array();
						?>
						<br />
						<select name="add_task_owner" id="add_task_owner">
							<option value="0"><?php _e('Assignee', 'cqpim') ?></option>
							<optgroup label="<?php _e('Team Members', 'cqpim'); ?>">
								<?php if(empty($project_contributors)) { ?>
									<option value="0"><?php _e('Me', 'cqpim'); ?></option>
								<?php } ?>
								<?php
								foreach($project_contributors as $contributor) {
									$team_details = get_post_meta($contributor['team_id'], 'team_details', true);
									$team_name = isset($team_details['team_name']) ? $team_details['team_name'] : '';
									$team_job = isset($team_details['team_job']) ? $team_details['team_job'] : '';
									echo '<option value="' . $contributor['team_id'] . '">' . $team_name . ' - ' . $team_job . '</option>';
								}
								?>
							</optgroup>
						</select>
						<br /><br />
						<button class="cancel-colorbox cqpim_button op font-white bg-red rounded_2"><?php _e('Cancel', 'cqpim'); ?></button>
						<button class="save-task metabox-add-button cqpim_button font-white bg-green rounded_2 right op"><?php _e('Add Task', 'cqpim'); ?></button>
						<div class="clear"></div>
						<div id="add-task-messages"></div>
					</div>
				</div>	
			</div>
			
			<!-- Delete Task Colorbox -->
			
			<div id="delete-task-div-container" style="display:none">
				<div id="delete-task" class="delete-task-div">
					<div style="padding:12px">
						<h3><?php _e('Are you sure?', 'cqpim'); ?></h3>
						<p><?php _e('Deleting this task will also delete the attached subtasks. This action cannot be undone.', 'cqpim'); ?></p>
						<br />
						<button class="cancel_delete_task cqpim_button op font-white bg-red rounded_2"><?php _e('Cancel', 'cqpim'); ?></button>
						<button id="delete-task-button" class="delete_stage metabox-add-button cqpim_button font-white bg-green rounded_2 right op" value=""><?php _e('Delete', 'cqpim'); ?></button>
						<div class="clear"></div>
						<div id="delete-task-messages"></div>
					</div>
				</div>
			</div>
			
			<!-- Add SubTask Colorbox -->
			
			<div id="add-subtask-div-container" style="display:none">
				<div id="add-subtask-div" class="add-subtask-div">
					<div style="padding:12px">
						<h3><?php _e('Add Subtask', 'cqpim'); ?></h3>
						<input type="hidden" id="add_subtask_milestone_id" value="" />
						<input type="hidden" id="add_subtask_parent_id" value="" />
						<input type="hidden" id="add_subtask_project_id" value="<?php echo $post->ID; ?>" />
						<input style="width:100%" type="text" id="add_subtask_title" placeholder="<?php _e('Task title', 'cqpim'); ?>"/><br /><br />					
						<textarea style="width:100%;height:100px" id="add_subtask_description" placeholder="<?php _e('Task description', 'cqpim'); ?>"></textarea><br /><br />
						<input style="width:100%"class="datepicker" type="text" id="add_subtask_start" placeholder="<?php _e('Start Date', 'cqpim'); ?>"/>
						<input style="width:100%"class="datepicker" type="text" id="add_subtask_finish" placeholder="<?php _e('Deadline', 'cqpim'); ?>"/><br /><br />
						<input style="width:100%" type="text" id="add_subtask_time" placeholder="<?php _e('Estimated Time (in decimal format, eg. 4.5 hours)', 'cqpim'); ?>"/>																		
						<div class="clear"></div>
						<?php
						$project_contributors = get_post_meta($post->ID, 'project_contributors', true);
						$project_contributors = $project_contributors&&is_array($project_contributors)?$project_contributors:array();
						?>
						<br />
						<select name="add_subtask_owner" id="add_subtask_owner">
							<option value="0"><?php _e('Assignee', 'cqpim') ?></option>
							<optgroup label="<?php _e('Team Members', 'cqpim'); ?>">
								<?php if(empty($project_contributors)) { ?>
									<option value="0"><?php _e('Me', 'cqpim'); ?></option>
								<?php } ?>
								<?php
								foreach($project_contributors as $contributor) {
									$team_details = get_post_meta($contributor['team_id'], 'team_details', true);
									$team_name = isset($team_details['team_name']) ? $team_details['team_name'] : '';
									$team_job = isset($team_details['team_job']) ? $team_details['team_job'] : '';
									echo '<option value="' . $contributor['team_id'] . '">' . $team_name . ' - ' . $team_job . '</option>';
								}
								?>
							</optgroup>
						</select>
						<br /><br />
						<button class="cancel-colorbox cqpim_button op font-white bg-red rounded_2"><?php _e('Cancel', 'cqpim'); ?></button>
						<button class="save-subtask metabox-add-button cqpim_button font-white bg-green rounded_2 right op"><?php _e('Add Subtask', 'cqpim'); ?></button>
						<div class="clear"></div>
						<div id="add-subtask-messages"></div>
					</div>
				</div>	
			</div>
			
			<!-- Delete SubTask Colorbox -->
			
			<div id="delete-subtask-div-container" style="display:none">
				<div id="delete-subtask" class="delete-subtask-div">
					<div style="padding:12px">
						<h3><?php _e('Are you sure?', 'cqpim'); ?></h3>
						<p><?php _e('Are you sure you want to delete this subtask? This action cannot be undone.', 'cqpim'); ?></p>
						<br />
						<button class="cancel_delete_task cqpim_button op font-white bg-red rounded_2"><?php _e('Cancel', 'cqpim'); ?></button>
						<button id="delete-subtask-button" class="delete_stage metabox-add-button cqpim_button font-white bg-green rounded_2 right op" value=""><?php _e('Delete', 'cqpim'); ?></button>
						<div class="clear"></div>
						<div id="delete-subtask-messages"></div>
					</div>
				</div>
			</div>
			
			<!-- Edit Task Colorbox -->
			
			<div id="edit-task-div-container" style="display:none">
				<div id="edit-task" class="edit-task-div">
					<div style="padding:12px">
						<h3><?php _e('Edit Task', 'cqpim'); ?></h3>
						<input type="hidden" name="edit_task_id" id="edit_task_id" value="" />
						<span class="label"><strong><?php _e('Title:', 'cqpim'); ?></strong></span>
						<input type="text" name="edit_task_title" id="edit_task_title" value="" placeholder="<?php _e('Task title', 'cqpim'); ?>"/>							
						<span class="label"><strong><?php _e('Description:', 'cqpim'); ?></strong></span>
						<textarea style="width:100%;height:100px" name="edit_task_description" id="edit_task_description" placeholder="<?php _e('Task description', 'cqpim'); ?>"></textarea>
						<span class="label"><strong><?php _e('Start:', 'cqpim'); ?></strong></span>
						<input class="datepicker" type="text" name="edit_task_start" id="edit_task_start" value="" placeholder="<?php _e('Start Date', 'cqpim'); ?>"/>														
						<span class="label"><strong><?php _e('Deadline:', 'cqpim'); ?></strong></span>
						<input class="datepicker" type="text" name="edit_task_finish" id="edit_task_finish" value="" placeholder="<?php _e('Deadline', 'cqpim'); ?>"/>	
						<span class="label"><strong><?php _e('Est Time:', 'cqpim'); ?></strong></span>
						<input type="text" name="edit_task_time" id="edit_task_time" value="" placeholder="<?php _e('Estimated Time (in decimal format, eg. 4.5 hours)', 'cqpim'); ?>"/>	
						<br /><br />
						<button class="cancel-colorbox cqpim_button op font-white bg-red rounded_2"><?php _e('Cancel', 'cqpim'); ?></button>
						<button class="update-task metabox-add-button cqpim_button font-white bg-green rounded_2 right op" value=""><?php _e('Save', 'cqpim'); ?></button>
						<div class="clear"></div>
						<div id="edit_task_messages"></div>
					</div>
				</div>	
			</div>	
	
	

	<?php
}
add_action( 'save_post', 'save_pto_support_elements_metabox_data' );
function save_pto_support_elements_metabox_data( $post_id ){
	if ( ! isset( $_POST['support_elements_metabox_nonce'] ) )
	    return $post_id;
	$nonce = $_POST['support_elements_metabox_nonce'];
	if ( ! wp_verify_nonce( $nonce, 'support_elements_metabox' ) )
	    return $post_id;
	if ( defined( 'DOING_AUTOSAVE' ) && DOING_AUTOSAVE ) 
	    return $post_id;
	if ( 'page' == $_POST['post_type'] ) {
	    if ( ! current_user_can( 'edit_page', $post_id ) )
	        return $post_id;
	  	} else {
	    if ( ! current_user_can( 'edit_post', $post_id ) )
	        return $post_id;
	}
	$quote_elements = get_post_meta($post_id, 'quote_elements', true);
	if(isset($_POST['added_element_title'])) {
		$title_array = $_POST['added_element_title'];
		$quote_elements = get_post_meta($post_id, 'quote_elements', true);
		foreach($title_array as $key => $to_add) {
			$title = $to_add;
			$milestone_id = $_POST['added_element_milestone_id'][$key];
			$milestone_start = $_POST['added_element_start'][$key];			
			$milestone_start = pto_convert_date($milestone_start);
			$milestone_deadline = $_POST['added_element_finish'][$key];
			$milestone_deadline = pto_convert_date($milestone_deadline);
			$milestone_weight = $_POST['element_weight'][$key];
			$cost = $_POST['added_element_cost'][$key];
			$acost = $_POST['added_element_acost'][$key];
			$status = $_POST['added_element_status'][$key];
			$already_comp = isset($quote_elements[$key]['already_comp']) ? $quote_elements[$key]['already_comp'] : false;
			$quote_elements[$key] = array(
				'deadline' => $milestone_deadline,
				'title' => $title,
				'start' => $milestone_start,
				'id' => $milestone_id,
				'cost' => $cost,
				'acost' => $acost,
				'status' => $status,
				'already_comp' => $already_comp,
				'weight' => $milestone_weight
			);
		}
		update_post_meta($post_id, 'quote_elements', $quote_elements);
	}
	if(isset($_POST['delete_stage'])) {
		$stages_to_delete = $_POST['delete_stage'];
		$quote_elements = get_post_meta($post_id, 'quote_elements', true);
		foreach($stages_to_delete as $key => $delete) {
			unset($quote_elements[$delete]);
			$args = array(
				'post_type' => 'cqpim_tasks',
				'posts_per_page' => -1,
				'meta_key' => 'milestone_id',
				'meta_value' => $delete,
				'orderby' => 'date',
				'order' => 'ASC'
			);
			$tasks = get_posts($args);
			foreach($tasks as $task) {
				wp_delete_post($task->ID);		
			}
		}
		$new_quote_elements = array();
		foreach($quote_elements as $key => $element) {
			$new_quote_elements[$key] = $element;
		}
		update_post_meta($post_id, 'quote_elements', $new_quote_elements);
	}
}