<?php
/**
 *  Bugs CPT
 */
if ( ! function_exists('pto_bugs_cpt') ) {
	// Register Custom Post Type
	function pto_bugs_cpt() {
		if(current_user_can('cqpim_create_new_bug') && current_user_can('publish_cqpim_bugs')) {
			$form_caps = array('create_posts' => false);
		} else {
			$form_caps = array('create_posts' => false);
		}	
		$labels = array(
			'name'                => _x( 'Bugs', 'Post Type General Name', 'cqpim-bugs' ),
			'singular_name'       => _x( 'Bugs', 'Post Type Singular Name', 'cqpim-bugs' ),
			'menu_name'           => __( 'Bugs', 'cqpim-bugs' ),
			'parent_item_colon'   => __( 'Bugs:', 'cqpim-bugs' ),
			'all_items'           => __( 'Bugs', 'cqpim-bugs' ),
			'view_item'           => __( 'Bugs', 'cqpim-bugs' ),
			'add_new_item'        => __( 'Bugs', 'cqpim-bugs' ),
			'add_new'             => __( 'Bugs', 'cqpim-bugs' ),
			'edit_item'           => __( 'Edit Bug', 'cqpim-bugs' ),
			'update_item'         => __( 'Bugs', 'cqpim-bugs' ),
			'search_items'        => __( 'Bugs', 'cqpim-bugs' ),
			'not_found'           => __( 'Bugs', 'cqpim-bugs' ),
			'not_found_in_trash'  => __( 'Bugs', 'cqpim-bugs' ),
		);
		$args = array(
			'label'               => __( 'Bugs', 'cqpim-bugs' ),
			'description'         => __( 'Bugs', 'cqpim-bugs' ),
			
			'labels'              => $labels,
			'capabilities'        => $form_caps,
			'map_meta_cap' => true, 
			'supports'            => array( 'title' ),
			'hierarchical'        => false,
			'public'              => false,
			'show_ui'             => true,
			'show_in_nav_menus'   => false,
			'show_in_menu'		  => false,	
			'show_in_admin_bar'   => true,
			'menu_position'       => 1,
			'menu_icon'           => plugins_url() . "/img/contact.png",
			'can_export'          => true,
			'has_archive'         => false,
			'exclude_from_search' => true,
			'publicly_queryable'  => true,
			'capability_type'     => array('cqpim_bug', 'cqpim_bugs'),
			'map_meta_cap'        => true,
			'query_var'			  => true,
			'rewrite'			  => array('slug' => get_option('cqpim_bug_slug')),
		);
		register_post_type( 'cqpim_bug', $args );
	}
	add_action( 'init', 'pto_bugs_cpt', 10 );
}