<?php
function pto_bug_log_metabox_callback( $post ) {
 	wp_nonce_field( 
 	 	'bug_log_metabox', 
 	 	'bug_log_metabox_nonce' );
		$bug_updates = get_post_meta($post->ID, 'bug_updates', true);
		$bug_updates = array_reverse($bug_updates);
		$updates = count($bug_updates);
		$statuses = pto_get_bug_status();
		$avatar = get_option('cqpim_disable_avatars');
		$i = 0; ?>
			<style>
				.bug_update {
					border-bottom: 2px solid #eee;
					padding-bottom:10px;
					margin-bottom:10px;
				}
				.bug_update.last {
					margin-bottom:0px;
				}
				.update_title {
					padding-bottom:10px;
					margin-bottom:10px;
				}
				.bug_update.last .update_title {
					padding-bottom:0px;
					margin-bottom:0px;
				}
				.update_av {
					float:left;
				}
				.update_info {
					position:relative;
					width:calc(100% - 90px);
					float:right;
				}
				.update_status {
					position:absolute;
					top:0;
					right:10px;
				}
				.update_status span {
					text-transform:uppercase;
				}
				.update_update {
				}
				.bug_changes {
					margin:0 !important;
					font-size:12px;
				}
			</style>
		<div style="max-height:700px; overflow:auto">
			<?php foreach($bug_updates as $update) { 
				$updater = get_user_by('id', $update['user']); ?>
				<div class="bug_update<?php if(++$i === $updates) { echo ' last'; } ?>">
					<div class="update_title">
						<?php if(empty($avatar)) { ?>
							<div class="update_av">
								<?php echo get_avatar( $update['user'], 80, '', false, array('force_display' => true) ); ?>
							</div>
						<?php } ?>
						<div <?php if(!empty($avatar)) { ?>style="width:100%; float:none"<?php } ?> class="update_info">
							<p class="underline nobottom"><?php echo $updater->display_name; ?> - <?php echo date(get_option('cqpim_date_format') . ' H:i:s', $update['stamp']); ?></p>
							<?php if(!empty($update['changes'])) {
								foreach($update['changes'] as $change) {
									if($change['type'] == 's') {
										echo '<p class="bug_changes">';
										printf(__('Status changed from %1$s to %2$s', 'cqpim-bugs'), $statuses[$change['from']]['name'], $statuses[$change['to']]['name']);
										echo '</p>';
									} else {
										$from = get_post_meta($change['from'], 'team_details', true);
										$from = isset($from['team_name']) ? $from['team_name'] : '';
										$to = get_post_meta($change['to'], 'team_details', true);
										$to = isset($to['team_name']) ? $to['team_name'] : '';
										echo '<p class="bug_changes">';
										printf(__('Assignee changed from %1$s to %2$s', 'cqpim-bugs'), $from, $to);
										echo '</p>';
									}
								}
							}
							if(!empty($update['files'][0])) {
								echo '<p class="bug_changes">';
								_e('File Uploaded:', 'cqpim-bugs');
								$files = count($update['files']);
								$i = 0;
								foreach($update['files'] as $file) {
									if(!empty($file)) {
										$file_object = get_post($file);
										echo ' <a class="cqpim-link" href="' . $file_object->guid . '">' . $file_object->post_title . '</a>';
										if(++$i != $files) {
											echo ' | ';
										}
									}
								}
								echo '</p>';
							}
							?>
							<?php if(!empty($update['status'])) { ?>
								<div class="update_status">
									<span class="<?php echo $statuses[$update['status']]['class']; ?>"><?php echo $statuses[$update['status']]['name']; ?></span>
								</div>
							<?php } ?>
						</div>
						<div class="clear"></div>
					</div>
					<?php if(!empty($update['update'])) { ?>
						<div class="update_update">
							<?php echo wpautop($update['update']); ?>
						</div>
					<?php } ?>
				</div>
			<?php } ?>
		</div>
<?php }
add_action( 'save_post', 'save_pto_bug_log_metabox_data' );
function save_pto_bug_log_metabox_data( $post_id ){
	//  verify this came from the our screen and with proper authorization
	// Check if our nonce is set.
	if ( ! isset( $_POST['bug_log_metabox_nonce'] ) )
	    return $post_id;
	// Verify that the nonce is valid.
	$nonce = $_POST['bug_log_metabox_nonce'];
	if ( ! wp_verify_nonce( $nonce, 'bug_log_metabox' ) )
	    return $post_id;
	// If this is an autosave, our form has not been submitted, so we don't want to do anything.
	if ( defined( 'DOING_AUTOSAVE' ) && DOING_AUTOSAVE ) 
	    return $post_id;
	// Check the user's permissions.
	if ( 'page' == $_POST['post_type'] ) {
	    if ( ! current_user_can( 'edit_page', $post_id ) )
	        return $post_id;
	  	} else {
	    if ( ! current_user_can( 'edit_post', $post_id ) )
	        return $post_id;
	}
}