<?php
add_action( 'add_meta_boxes', 'add_pto_bugs_cpt_metaboxes' );
function add_pto_bugs_cpt_metaboxes(){
	$screen = get_current_screen();
	$assigned = pto_get_team_from_userid();
	if($screen->post_type == 'cqpim_bug') {
		global $post;
		$assignee = get_post_meta($post->ID, 'bug_assignee', true);
		if($assignee == $assigned && current_user_can('cqpim_view_bugs') || current_user_can('cqpim_view_all_bugs')) {
			add_meta_box( 
				'bug_details', 
				__('Bug Details', 'cqpim-bugs'),
				'pto_bug_details_metabox_callback', 
				'cqpim_bug', 
				'side',
				'high'
			);
			add_meta_box( 
				'bug_files', 
				__('Bug Files', 'cqpim-bugs'),
				'pto_bug_files_metabox_callback', 
				'cqpim_bug', 
				'normal',
				'high'
			);
			add_meta_box( 
				'bug_update', 
				__('Update Bug', 'cqpim-bugs'),
				'pto_bug_update_metabox_callback', 
				'cqpim_bug', 
				'normal',
				'high'
			);
			add_meta_box( 
				'bug_log', 
				__('Bug Log', 'cqpim-bugs'),
				'pto_bug_log_metabox_callback', 
				'cqpim_bug', 
				'normal',
				'high'
			);
		} else {
			add_meta_box( 
				'bug_denied', 
				__('Access Denied', 'cqpim'),
				'pto_bug_denied_metabox_callback', 
				'cqpim_bug',
				'normal'
			);	
			remove_meta_box( 'submitdiv', 'cqpim_project', 'side' );				
		}
	}
}
require_once( 'bug_details.php' );
require_once( 'bug_denied.php' );
require_once( 'bug_files.php' );
require_once( 'bug_update.php' );
require_once( 'bug_log.php' );