<?php
/**
* Plugin Name: Projectopia - Bug Tracker Add-On
* Description: The Projectopia Bug Tracker Plugin allows you and your clients to raise and track bugs against a project. It also provides a tool to convert support tickets to bugs and attach them to projects.
* Version: 2.0.1
* Author: Projectopia
* Author URI: http://projectopia.io
* Text Domain: cqpim-bugs
* Domain Path: /languages
*/
define('PTO_BUGS_VERSION', '2.0.1');
// Paths
define('PTO_BUGS_PATH', plugin_dir_path( __FILE__ ));
define('PTO_BUGS_DIRNAME', basename( plugin_basename( PTO_BUGS_PATH ) ));
define('PTO_BUGS_PLUGIN_URL', plugins_url() . '/' . PTO_BUGS_DIRNAME);
// Languages
function pto_bugs_plugin_setup() {
	load_plugin_textdomain('cqpim-bugs', false, dirname(plugin_basename(__FILE__)) . '/languages/');
} 
add_action('plugins_loaded', 'pto_bugs_plugin_setup');
register_activation_hook( __FILE__, 'pto_bugs_activation' );
function pto_bugs_activation() {
	if(is_plugin_active(PTO_DIRNAME . '/projectopia.php')) {
		$pto_version = PTO_VERSION;
		if($pto_version < '3.2.4') {
			$message = __('You need to have at least version 3.2.4 of the Projectopia Core plugin installed to use this add-on', 'cqpim-bugs');
			wp_die($message, 'Projectopia Core Plugin Version Problem');				
		} else {
		}
	} else {
		$message = __('You need to have the core Projectopia Plugin active to activate this Add-On', 'cqpim-bugs');
		wp_die($message, 'Projectopia Core Plugin Missing');
	}
	if(is_plugin_active('cqpim-bugs/cqpim-bugs.php')) {
		$message = __('You must deactivate and remove the old version of CQPIM Bug Tracker before installing this one. Make sure you make a backup of any language translation files so that you can reinstate them', 'cqpim-bugs');
		wp_die($message, 'Projectopia Core Plugin Version Problem');
	}
	// Fill in the settings
	update_option('cqpim_bug_slug', 'pto_bug');
	update_option('cqpim_new_bug_subject', '%%CURRENT_USER%% has raised a new bug: %%BUG_TITLE%% %%PIPING_ID%%');
	update_option('cqpim_update_bug_subject', '%%CURRENT_USER%% has updated a bug: %%BUG_TITLE%% %%PIPING_ID%%');
	$text = 'Dear %%NAME%%
%%CURRENT_USER%% has updated a bug. Please log in to your dashboard to action this request.
Bug Title: %%BUG_TITLE%%
Project Name: %%PROJECT_TITLE%%
Bug Status: %%BUG_STATUS%%
Assignee: %%BUG_ASSIGNEE%%
Bug Description: %%BUG_DESCRIPTION%%
Update: %%BUG_UPDATE%%
Best Regards
%%CURRENT_USER%%
%%COMPANY_NAME%%
Tel: %%COMPANY_TELEPHONE%%
Email: %%COMPANY_SALES_EMAIL%%';
	update_option('cqpim_update_bug_content', $text);
	$text = 'Dear %%NAME%%
%%CURRENT_USER%% has raised a new bug. Please log in to your dashboard to action this request.
Bug Title: %%BUG_TITLE%%
Project Name: %%PROJECT_TITLE%%
Bug Status: %%BUG_STATUS%%
Assignee: %%BUG_ASSIGNEE%%
Bug Description: %%BUG_DESCRIPTION%%
Best Regards
%%CURRENT_USER%%
%%COMPANY_NAME%%
Tel: %%COMPANY_TELEPHONE%%
Email: %%COMPANY_SALES_EMAIL%%';
	update_option('cqpim_new_bug_content', $text);
	$role = get_role('cqpim_client');
	$role->add_cap('read_private_cqpim_bugs');
	require_once('cpt/bugs.php');
	//flush_rewrite_rules();
}
// Includes
require_once( 'pto_bugs_functions.php' );
require_once( 'pto_bugs_cd.php' );
// Metaboxes
require_once('metaboxes/main.php');
// CPT
require_once('cpt/bugs.php');