<?php
/**
 *  Suppliers CPT
 */
if ( ! function_exists('pto_expenses_cpt') ) {
	function pto_expenses_cpt() {
		if(current_user_can('cqpim_create_new_expense') && current_user_can('publish_cqpim_expenses')) {
			$form_caps = array();
		} else {
			$form_caps = array('create_posts' => false);
		}	
		$labels = array(
			'name'                => _x( 'Expenses', 'Post Type General Name', 'cqpim-expenses' ),
			'singular_name'       => _x( 'Expense', 'Post Type Singular Name', 'cqpim-expenses' ),
			'menu_name'           => __( 'Expenses', 'cqpim-expenses' ),
			'parent_item_colon'   => __( 'Parent Expense:', 'cqpim-expenses' ),
			'all_items'           => __( 'Expenses', 'cqpim-expenses' ),
			'view_item'           => __( 'View Expense', 'cqpim-expenses' ),
			'add_new_item'        => __( 'Add New Expense', 'cqpim-expenses' ),
			'add_new'             => __( 'New Expense', 'cqpim-expenses' ),
			'edit_item'           => __( 'Edit Expense', 'cqpim-expenses' ),
			'update_item'         => __( 'Update Expense', 'cqpim-expenses' ),
			'search_items'        => __( 'Search Expenses', 'cqpim-expenses' ),
			'not_found'           => __( 'No Expenses found', 'cqpim-expenses' ),
			'not_found_in_trash'  => __( 'No Expenses found in trash', 'cqpim-expenses' ),
		);
		$args = array(
			'label'               => __( 'expenses', 'cqpim-expenses' ),
			'description'         => __( 'Expenses', 'cqpim-expenses' ),
			'labels'              => $labels,
			'supports'            => array( 'title' ),
			'hierarchical'        => false,
			'capabilities'        => $form_caps,
			'public'              => false,
			'show_ui'             => true,
			'show_in_nav_menus'   => false,
			'show_in_menu'		  => 'admin.php?page=cqpim-expenses',	
			'show_in_admin_bar'   => false,
			'menu_position'       => 5,
			'menu_icon'           => plugins_url() . "/img/contact.png",
			'can_export'          => true,
			'has_archive'         => true,
			'exclude_from_search' => true,
			'publicly_queryable'  => false,
			'capability_type'     => array('cqpim_expense', 'cqpim_expenses'),
			'map_meta_cap'        => true,
			'query_var'			  => true,
		);
		register_post_type( 'cqpim_expense', $args );
	}
	add_action( 'init', 'pto_expenses_cpt', 18 );
}
	add_action( 'init', 'pto_expense_cats', 0 );
	function pto_expense_cats() {
		$labels = array(
			'name'              => __( 'Expense Type', 'cqpim-expenses' ),
			'singular_name'     => __( 'Expense Type',  'cqpim-expenses' ),
			'search_items'      => __( 'Search Expense Types', 'cqpim-expenses' ),
			'all_items'         => __( 'All Expense Types', 'cqpim-expenses' ),
			'parent_item'       => __( 'Parent Expense Type', 'cqpim-expenses' ),
			'parent_item_colon' => __( 'Parent Expense Type:', 'cqpim-expenses' ),
			'edit_item'         => __( 'Edit Expense Type', 'cqpim-expenses' ),
			'update_item'       => __( 'Update Expense Type', 'cqpim-expenses' ),
			'add_new_item'      => __( 'Add New Expense Type', 'cqpim-expenses' ),
			'new_item_name'     => __( 'New Genre Expense Type', 'cqpim-expenses' ),
			'menu_name'         => __( 'Expense Types', 'cqpim-expenses' ),
		);
		$args = array(
			'hierarchical'      => true,
			'labels'            => $labels,
			'show_ui'           => true,
			'show_admin_column' => true,
			'query_var'         => true,
			'rewrite'           => false,
		);
		register_taxonomy( 'cqpim_expense_cat', array( 'cqpim_expense' ), $args );
	}