<?php
// Contact Details Metabox
function pto_expenses_details_metabox_callback( $post ) {
	// Add an nonce field so we can check for it later.
 	wp_nonce_field( 
 	 	'expenses_details_metabox', 
 	 	'expenses_details_metabox_nonce' ); 
		$supplier_id = get_post_meta($post->ID, 'supplier_id', true); 
		$project_id = get_post_meta($post->ID, 'project_id', true);
		$expense_date = get_post_meta($post->ID, 'expense_date', true);
		$owner = isset($post->post_author) ? $post->post_author : '';
		$owner = get_user_by('id', $owner);
		if(empty($owner)) {
			$owner = wp_get_current_user();
			$owner = $owner->display_name;
		}
		if(empty($expense_date)) {
			$expense_date = time();
		}
		$args = array(
			'post_type' => 'cqpim_supplier',
			'posts_per_page' => -1,
			'post_status' => 'private',
		);
		$suppliers = get_posts($args);
		?>
		<p><?php _e('Expense Owner', 'cqpim-expenses'); ?></p>
		<input type="text" disabled value="<?php echo isset($owner->display_name) ? $owner->display_name : ''; ?>" />
		<p><?php _e('Expense Date', 'cqpim-expenses'); ?></p>
		<input type="text" class="datepicker" name="expense_date" value="<?php echo date(get_option('cqpim_date_format'), $expense_date); ?>" />
		<p><?php _e('Supplier', 'cqpim-expenses'); ?></p>
		<select name="supplier_id" required>
			<option value=""><?php _e('Choose a Supplier', 'cqpim-expenses'); ?></option>
			<?php if(!empty($suppliers)) {
				foreach($suppliers as $supplier) { 
					$supplier_details = get_post_meta($supplier->ID, 'supplier_details', true); 
					$supplier_id_meta = isset($supplier_details['supplier_id']) ? $supplier_details['supplier_id'] : ''; ?>
					<option value="<?php echo $supplier->ID; ?>" <?php selected($supplier->ID, $supplier_id); ?>><?php echo $supplier_id_meta . ' - ' . $supplier->post_title; ?></option>
				<?php }
			} ?>
		</select>
		<p><?php _e('Project (optional)', 'cqpim-expenses'); ?></p>
		<select id="project_id" name="project_id">
			<option value=""><?php _e('Choose a Project', 'cqpim-expenses'); ?></option>
			<?php $args = array(
				'post_type' => 'cqpim_project',
				'posts_per_page' => -1,
				'post_status' => 'private',					
			);
			$projects = get_posts($args);
			if($projects) {
				foreach($projects as $project) { ?>
					<option value="<?php echo $project->ID; ?>" <?php echo selected($project->ID, $project_id); ?>><?php echo $project->post_title; ?></option>
				<?php }			
			} ?>
		</select>
		<br />
		<?php
		$auth = get_post_meta($post->ID, 'auth_active', true);
		$auth_limit = get_option('cqpim_expense_auth_limit');
		$totals = get_post_meta($post->ID, 'invoice_totals', true);
		$total = isset($totals['total']) ? $totals['total'] : '';
		$authorised = get_post_meta($post->ID, 'authorised', true); 
		$auth_details = get_post_meta($post->ID, 'auth_details', true);
		$by = isset($auth_details['by']) ? $auth_details['by'] : '';
		$at = isset($auth_details['at']) ? $auth_details['at'] : '';
		$for = isset($auth_details['for']) ? $auth_details['for'] : '';
		if(!empty($at)) {
			$at = date(get_option('cqpim_date_format') . ' H:i', $at);
		}
		$auth_requested = get_post_meta($post->ID, 'auth_requested', true);
		$auth_requested_details = get_post_meta($post->ID, 'auth_requested_details', true);
		$rby = isset($auth_requested_details['by']) ? $auth_requested_details['by'] : '';
		$rat = isset($auth_requested_details['at']) ? $auth_requested_details['at'] : '';
		if(!empty($rat)) {
			$rat = date(get_option('cqpim_date_format') . ' H:i', $rat);
		}
		if(!empty($auth) && !current_user_can('cqpim_bypass_expense_auth')) {
			if(empty($authorised)) { 
				if(empty($auth_requested)) { 
					if(empty($auth_limit)) { ?>
						<div class="cqpim-alert cqpim-alert-warning alert-display"><?php _e('This expense requires authorisation. Click "Request Authorisation" to send your request to an admin.', 'cqpim-expenses'); ?></div>
						<a class="request_auth cqpim_button cqpim_button_link font-white bg-blue rounded_2 block" data-id="<?php echo $post->ID; ?>" href="#"><?php _e('Request Authorisation', 'cqpim-expenses'); ?></a>
					<?php } else {
						if($total >= $auth_limit) { ?>
							<div class="cqpim-alert cqpim-alert-warning alert-display"><?php _e('Expenses of this value require authorisation. Click "Request Authorisation" to send your request to an admin.', 'cqpim-expenses'); ?></div>
							<a class="request_auth cqpim_button cqpim_button_link font-white bg-blue rounded_2 block" data-id="<?php echo $post->ID; ?>" href="#"><?php _e('Request Authorisation', 'cqpim-expenses'); ?></a>
						<?php } else {  ?>
						<?php } ?>						
					<?php } ?>
				<?php } else { ?>
					<div class="cqpim-alert cqpim-alert-success alert-display"><?php printf(__('This expense was sent for authorisation by %1$s on %2$s', 'cqpim-expenses'), $rby, $rat); ?></div>					
					<a class="request_auth cqpim_button cqpim_button_link font-white bg-blue rounded_2 block" data-id="<?php echo $post->ID; ?>" href="#"><?php _e('Resend Authorisation Request', 'cqpim-expenses'); ?></a>
				<?php } ?>
			<?php } else { 
				if($authorised == 1) { ?>
					<div class="cqpim-alert cqpim-alert-success alert-display"><?php printf(__('This expense was authorised by %1$s on %2$s', 'cqpim-expenses'), $by, $at); ?></div>					
					<?php if(!empty($for)) { ?>
						<div class="cqpim-alert cqpim-alert-info alert-display"><?php printf(__('Expense Authorisation Notes: %1$s', 'cqpim-expenses'), $for); ?></div>
					<?php } ?>
				<?php } 
				if($authorised == 2) { ?>
					<div class="cqpim-alert cqpim-alert-danger alert-display"><?php printf(__('This expense was declined by %1$s on %2$s', 'cqpim-expenses'), $by, $at); ?></div>	
					<?php if(!empty($for)) { ?>
						<div class="cqpim-alert cqpim-alert-info alert-display"><?php printf(__('Expense Declined Reason: %1$s', 'cqpim-expenses'), $for); ?></div>
					<?php } ?>
					<a class="request_auth cqpim_button cqpim_button_link font-white bg-blue rounded_2 block" data-id="<?php echo $post->ID; ?>" href="#"><?php _e('Resend Authorisation Request', 'cqpim-expenses'); ?></a>
				<?php } ?>
			<?php } ?>
		<?php } else { ?>
		<?php } ?>
		<?php if(current_user_can('cqpim_auth_expense') && !empty($auth_requested) && empty($authorised)) { ?>
			<div class="cqpim-alert cqpim-alert-success alert-display"><?php printf(__('This expense was sent for authorisation by %1$s on %2$s', 'cqpim-expenses'), $rby, $rat); ?></div>					
			<a class="auth_launch cqpim_button cqpim_button_link font-white bg-blue rounded_2 block mt-10" href="#"><?php _e('Authorise / Decline Expense', 'cqpim-expenses'); ?></a>
		<?php } ?>
		<?php if(current_user_can('cqpim_auth_expense') && empty($auth_requested) && !empty($authorised)) { ?>
			<?php if($authorised == 1) { ?>
				<div class="cqpim-alert cqpim-alert-success alert-display"><?php printf(__('This expense was authorised by %1$s on %2$s', 'cqpim-expenses'), $by, $at); ?></div>					
			<?php } 
			if($authorised == 2) { ?>
				<div class="cqpim-alert cqpim-alert-danger alert-display"><?php printf(__('This expense was declined by %1$s on %2$s', 'cqpim-expenses'), $by, $at); ?></div>	
				<?php if(!empty($for)) { ?>
					<div class="cqpim-alert cqpim-alert-info alert-display"><?php printf(__('Expense Declined Reason: %1$s', 'cqpim-expenses'), $for); ?></div>
				<?php } ?>
			<?php } ?>		
		<?php } ?>
		<?php if(current_user_can('publish_cqpim_expenses')) { ?>
			<a class="save cqpim_button cqpim_button_link font-white bg-blue rounded_2 block mt-10" href="#"><?php _e('Update Expense', 'cqpim-expenses'); ?></a>
		<?php } ?>
		<?php if(current_user_can('delete_cqpim_expenses')) { ?>
			<a id="delete_task" class="cqpim_button cqpim_button_link font-white bg-red rounded_2 block mt-10" data-id="<?php echo $post->ID; ?>" href="#"><?php _e('Delete Expense', 'cqpim-expenses'); ?></a>
		<?php } ?>	
		<div id="expense-messages"></div>
		<div id="auth_conf_box_container" style="display:none">
			<div id="auth_conf_box">
				<div style="padding:12px">
					<h3><?php _e('Authorise Expense', 'cqpim'); ?></h3>
					<p><?php _e('Approve or Decline this request. If you decline the request, you should indicate why in the notes.', 'cqpim-expenses'); ?> </p><br />
					<select id="expense_auth_decision">
						<option value="1"><?php _e('Authorise', 'cqpim-expenses'); ?></option>
						<option value="2"><?php _e('Decline', 'cqpim-expenses'); ?></option>
					</select>
					<br /><br />
					<textarea id="expense_auth_notes"></textarea>
					<br /><br />
					<div id="expense_auth_messages"></div>
					<button class="cancel-colorbox cqpim_button font-red border-red op"><?php _e('Cancel', 'cqpim-expenses'); ?></button>
					<button class="process_auth cqpim_button font-green border-green right op" value="<?php echo $post->ID; ?>"><?php _e('Update', 'cqpim-expenses'); ?></button>
				</div>
			</div>
		</div>
		<?php
}
// Save Contact Details Fields
add_action( 'save_post', 'save_pto_expenses_details_metabox_data' );
function save_pto_expenses_details_metabox_data( $post_id ){
	//  verify this came from the our screen and with proper authorization
	// Check if our nonce is set.
	if ( ! isset( $_POST['expenses_details_metabox_nonce'] ) )
	    return $post_id;
	// Verify that the nonce is valid.
	$nonce = $_POST['expenses_details_metabox_nonce'];
	if ( ! wp_verify_nonce( $nonce, 'expenses_details_metabox' ) )
	    return $post_id;
	// If this is an autosave, our form has not been submitted, so we don't want to do anything.
	if ( defined( 'DOING_AUTOSAVE' ) && DOING_AUTOSAVE ) 
	    return $post_id;
	// Check the user's permissions.
	if ( 'page' == $_POST['post_type'] ) {
	    if ( ! current_user_can( 'edit_page', $post_id ) )
	        return $post_id;
	  	} else {
	    if ( ! current_user_can( 'edit_post', $post_id ) )
	        return $post_id;
	}
	$expense_date = isset($_POST['expense_date']) ? $_POST['expense_date'] : '';
	$expense_date_stamp = pto_convert_date($expense_date);
	update_post_meta($post_id, 'expense_date', $expense_date_stamp); 
	$supplier_id = isset($_POST['supplier_id']) ? $_POST['supplier_id'] : '';
	update_post_meta($post_id, 'supplier_id', $supplier_id); 
	$project_id = isset($_POST['project_id']) ? $_POST['project_id'] : '';
	update_post_meta($post_id, 'project_id', $project_id); 
	// Currency
	$currency = get_option('currency_symbol');
	$currency_code = get_option('currency_code');
	$currency_position = get_option('currency_symbol_position');
	$currency_space = get_option('currency_symbol_space'); 
	$client_currency = get_post_meta($supplier_id, 'currency_symbol', true);
	$client_currency_code = get_post_meta($supplier_id, 'currency_code', true);
	$client_currency_space = get_post_meta($supplier_id, 'currency_space', true);		
	$client_currency_position = get_post_meta($supplier_id, 'currency_position', true);
	if(!empty($quote_currency)) {
		update_post_meta($post_id, 'currency_symbol', $quote_currency);
	} else {
		if(!empty($client_currency)) {
			update_post_meta($post_id, 'currency_symbol', $client_currency);
		} else {
			update_post_meta($post_id, 'currency_symbol', $currency);
		}
	}
	if(!empty($quote_currency_code)) {
		update_post_meta($post_id, 'currency_code', $quote_currency_code);
	} else {
		if(!empty($client_currency_code)) {
			update_post_meta($post_id, 'currency_code', $client_currency_code);
		} else {
			update_post_meta($post_id, 'currency_code', $currency_code);
		}
	}
	if(!empty($quote_currency_space)) {
		update_post_meta($post_id, 'currency_space', $quote_currency_space);
	} else {
		if(!empty($client_currency_space)) {
			update_post_meta($post_id, 'currency_space', $client_currency_space);
		} else {
			update_post_meta($post_id, 'currency_space', $currency_space);
		}
	}
	if(!empty($quote_currency_position)) {
		update_post_meta($post_id, 'currency_position', $quote_currency_position);
	} else {
		if(!empty($client_currency_position)) {
			update_post_meta($post_id, 'currency_position', $client_currency_position);
		} else {
			update_post_meta($post_id, 'currency_position', $currency_position);
		}
	}
	// Tax
	$tax_app = get_post_meta($post_id, 'tax_set', true);
	if(empty($tax_app)) {
		$supplier_details = get_post_meta($supplier_id, 'supplier_details', true);
		$supplier_tax = isset($supplier_details['supplier_tax_pc']) ? $supplier_details['supplier_tax_pc'] : '';
		$supplier_stax = isset($supplier_details['supplier_stax_pc']) ? $supplier_details['supplier_stax_pc'] : '';
		if(!empty($supplier_tax)) {
			update_post_meta($post_id, 'tax_applicable', 1);
			update_post_meta($post_id, 'tax_set', 1);	
			update_post_meta($post_id, 'tax_rate', $supplier_tax);	
			if(!empty($supplier_stax)) {
				update_post_meta($post_id, 'stax_applicable', 1);
				update_post_meta($post_id, 'stax_set', 1);	
				update_post_meta($post_id, 'stax_rate', $supplier_stax);			
			} else {
				update_post_meta($post_id, 'stax_applicable', 0);
				update_post_meta($post_id, 'stax_set', 1);
				update_post_meta($post_id, 'stax_rate', 0);				
			}
		} else {
			update_post_meta($post_id, 'tax_applicable', 0);
			update_post_meta($post_id, 'tax_set', 1);
			update_post_meta($post_id, 'tax_rate', 0);			
		}
	}
	$auth = get_option('cqpim_activate_expense_auth');
	update_post_meta($post_id, 'auth_active', $auth);
}