<?php
// Contact Details Metabox
function pto_expenses_items_metabox_callback( $post ) {
	// Add an nonce field so we can check for it later.
 	wp_nonce_field( 
 	 	'expenses_items_metabox', 
 	 	'expenses_items_metabox_nonce' );
		$line_items = get_post_meta($post->ID, 'line_items', true); 
		$supplier = get_post_meta($post->ID, 'supplier_id', true);
		$supplier_details = get_post_meta($supplier, 'supplier_details', true);
		$tax_name = isset($supplier_details['supplier_tax_name']) ? $supplier_details['supplier_tax_name'] : '';
		$stax_name = isset($supplier_details['supplier_stax_name']) ? $supplier_details['supplier_stax_name'] : '';		
		$tax_applicable = get_post_meta($post->ID, 'tax_applicable', true);
		$stax_applicable = get_post_meta($post->ID, 'stax_applicable', true);
		if(!empty($supplier)) {
		?>
		<table style="table-layout: fixed" class="cqpim_table">
			<thead>
				<tr>
					<th style="width:10%"><?php _e('Qty', 'cqpim-expenses'); ?></th>
					<th style="width:45%"><?php _e('Description', 'cqpim-expenses'); ?></th>
					<th style="width:12.5%"><?php _e('Price', 'cqpim-expenses'); ?> (<?php echo pto_calculate_currency($post->ID); ?>)</th>
					<th style="width:12.5%"><?php _e('Total', 'cqpim-expenses'); ?> (<?php echo pto_calculate_currency($post->ID); ?>)</th>
					<?php if(!empty($tax_applicable)) { ?>
						<th style="width:7.5%"><?php printf(__('Ex. %1$s', 'cqpim-expenses'), $tax_name); ?></th>
						<?php $tax = true; ?>
					<?php } ?>
					<?php if(!empty($stax_applicable)) { ?>
						<th style="width:7.5%"><?php printf(__('Ex. %1$s', 'cqpim-expenses'), $stax_name); ?></th>
						<?php $stax = true; ?>
					<?php } ?>
					<?php
						$width = 5;
						if(empty($tax)) {
							$width = 12.5;
						}
						if(empty($tax) && empty($stax)) {
							$width = 20;
						}
					?>
					<th style="width:<?php echo $width; ?>%">&nbsp;</th>
				</tr>
			</thead>
			</table>
		<div class="repeater">	
			<div data-repeater-list="group-a">
					<?php if($line_items) { 
						$i = 0;
						foreach($line_items as $item) { ?>
							<div class="line_item" data-repeater-item>
								<table style="table-layout: fixed" class="cqpim_table invoice-items">
									<tbody>
										<tr>							
											<td style="width:10%"><span class="cqpim_mobile"><?php _e('Qty', 'cqpim-expenses'); ?></span><input data-row="<?php echo $i; ?>" id="invoice_qty_<?php echo $i; ?>" class="invoice_qty" type="text" name="qty" value="<?php echo $item['qty']; ?>" placeholder="<?php _e('Quantity', 'cqpim-expenses'); ?>" required /></td>
											<td style="width:45%"><span class="cqpim_mobile"><?php _e('Description', 'cqpim-expenses'); ?></span><input data-row="<?php echo $i; ?>" id="invoice_desc_<?php echo $i; ?>" class="invoice_desc" type="text" name="desc" value="<?php echo $item['desc']; ?>" placeholder="<?php _e('Description', 'cqpim-expenses'); ?>" required /></td>
											<td style="width:12.5%"><span class="cqpim_mobile"><?php _e('Price', 'cqpim-expenses'); ?></span><input data-row="<?php echo $i; ?>" id="invoice_price_<?php echo $i; ?>" class="invoice_price" type="text" name="price" value="<?php echo $item['price']; ?>" placeholder="<?php _e('Price', 'cqpim-expenses'); ?> (<?php echo pto_calculate_currency($post->ID); ?>)" required /></td>
											<td style="width:12.5%"><span class="cqpim_mobile"><?php _e('Line Total', 'cqpim-expenses'); ?></span><input data-row="<?php echo $i; ?>" id="invoice_line_total_<?php echo $i; ?>" class="invoice_line_total" type="text" name="line_total" value="<?php echo $item['sub']; ?>" placeholder="<?php _e('Subtotal', 'cqpim-expenses'); ?>" readonly /></td>
											<?php if(!empty($tax_applicable)) { ?>
												<td style="width:7.5%"><span class="cqpim_mobile"><?php printf(__('Exclude %1$s', 'cqpim-expenses'), $tax_name); ?></span> <input data-row="<?php echo $i; ?>" id="invoice_line_tax_<?php echo $i; ?>" name="line_tax" class="line_tax" value="1" style="width:auto" type="checkbox" <?php if(!empty($item['tax_ex']) && $item['tax_ex'] == 1) { echo 'checked="checked"'; } ?> /></td>
											<?php } ?>
											<?php if(!empty($stax_applicable)) { ?>
												<td style="width:7.5%"><span class="cqpim_mobile"><?php printf(__('Exclude %1$s', 'cqpim-expenses'), $stax_name); ?></span> <input data-row="<?php echo $i; ?>" id="invoice_line_stax_<?php echo $i; ?>" name="line_stax" class="line_stax" value="1" style="width:auto" type="checkbox" <?php if(!empty($item['stax_ex']) && $item['stax_ex'] == 1) { echo 'checked="checked"'; } ?> /></td>		
											<?php } ?>
											<td style="padding:0; text-align:center; width:<?php echo $width; ?>%"><input data-row="<?php echo $i; ?>" class="line_delete cqpim_button cqpim_small_button bg-red rounded_2 border-red op" data-repeater-delete type="button" value=""/></td>
										</tr>
									</tbody>
								</table>
							</div>
					<?php $i++;
						} 
					} else { ?>
						<div class="line_item" data-repeater-item>
							<table style="table-layout: fixed" class="cqpim_table invoice-items">
								<tbody>
									<tr>
										<td style="width:10%"><input data-row="0" id="invoice_qty" class="invoice_qty" type="text" name="qty" value="" placeholder="<?php _e('Quantity', 'cqpim-expenses'); ?>" required /></td>
										<td style="width:45%"><input data-row="0" id="invoice_desc" class="invoice_desc" type="text" name="desc" value="" placeholder="<?php _e('Description', 'cqpim-expenses'); ?>" required /></td>
										<td style="width:12.5%"><input data-row="0" id="invoice_price" class="invoice_price" type="text" name="price" value="" placeholder="<?php _e('Price', 'cqpim-expenses'); ?> (<?php echo pto_calculate_currency($post->ID); ?>)" required /></td>
										<td style="width:12.5%"><input data-row="0" id="invoice_line_total" class="invoice_line_total" type="text" name="line_total" value="" placeholder="<?php _e('Subtotal', 'cqpim-expenses'); ?>" readonly required /></td>
										<?php if(!empty($tax_applicable)) { ?>
											<td style="width:7.5%"><input data-row="0" id="invoice_line_tax" name="line_tax" class="line_tax" style="width:auto" type="checkbox" value="1" /></td>
										<?php } ?>
										<?php if(!empty($stax_applicable)) { ?>
											<td style="width:7.5%"><input data-row="0" id="invoice_line_stax" name="line_stax" class="line_stax" style="width:auto" type="checkbox" value="1" /></td>		
										<?php } ?>
										<td style="padding:0; text-align:center; width:<?php echo $width; ?>%"><input data-row="0" class="line_delete cqpim_button cqpim_small_button bg-red rounded_2 border-red op" data-repeater-delete type="button" value=""/></td>
									</tr>
								</tbody>
							</table>
						</div>
					<?php } ?>
			</div>
			<input class="add_line_item_row cqpim_button bg-green rounded_2 border-green op" data-repeater-create type="button" value=""/>
		</div>
		<p class="underline"><?php _e('Expense Totals', 'cqpim-expenses'); ?></p>
		<div class="totals">
			<?php 
				$vat_rate = get_post_meta($post->ID, 'tax_rate', true);
				$svat_rate = get_post_meta($post->ID, 'stax_rate', true);
				if(!empty($vat_rate) || pto_is_edit_page('new') && !empty($vat_active)) {
					$subtotal = __('Subtotal', 'cqpim-expenses');
				} else {
					$subtotal = __('Total', 'cqpim-expenses');
				}
				$totals = get_post_meta($post->ID, 'invoice_totals', true);
				$sub = isset($totals['sub']) ? $totals['sub'] : '';
				$vat = isset($totals['tax']) ? $totals['tax'] : '';
				$svat = isset($totals['stax']) ? $totals['stax'] : '';
				$total = isset($totals['total']) ? $totals['total'] : '';
			?>
			<p><strong><?php echo $subtotal; ?> (<?php echo pto_calculate_currency($post->ID); ?>)</strong></p>
			<input class="total_fields" type="text" name="invoice_subtotal" id="invoice_subtotal" value="<?php echo $sub; ?>" />
			<input type="hidden" id="tax_rate" name="tax_rate" value="<?php echo isset($vat_rate) ? $vat_rate : 0; ?>" />
			<input type="hidden" id="stax_rate" name="stax_rate" value="<?php echo isset($svat_rate) ? $svat_rate : 0; ?>" />
			<?php if(!empty($vat_rate) || pto_is_edit_page('new') && !empty($vat_active)) { 
				if(!empty($tax_applicable)) { ?>
				<p><strong><?php echo $tax_name; ?> (<?php echo pto_calculate_currency($post->ID); ?>)</strong></p>
				<input class="total_fields" type="text" name="invoice_vat" id="invoice_vat" value="<?php echo $vat; ?>" />
				<?php } ?>
				<?php if(!empty($stax_applicable)) { ?>
					<p><strong><?php echo $stax_name; ?> (<?php echo pto_calculate_currency($post->ID); ?>)</strong></p>
					<input class="total_fields" type="text" name="invoice_svat" id="invoice_svat" value="<?php echo $svat; ?>" />
				<?php } ?>
				<p><strong><?php _e('Total', 'cqpim-expenses'); ?> (<?php echo pto_calculate_currency($post->ID); ?>)</strong></p>
				<input class="total_fields" type="text" name="invoice_total" id="invoice_total" value="<?php echo $total; ?>" />
			<?php } else {
				$total = $sub;
			} ?>
		</div>
		<?php } else { ?>
			<?php _e('You must select a supplier before you can add line items.', 'cqpim-expenses'); ?>
		<?php } ?>
		<div class="clear"></div>
		<?php
}
// Save Contact Details Fields
add_action( 'save_post', 'save_pto_expenses_items_metabox_data' );
function save_pto_expenses_items_metabox_data( $post_id ){
	//  verify this came from the our screen and with proper authorization
	// Check if our nonce is set.
	if ( ! isset( $_POST['expenses_items_metabox_nonce'] ) )
	    return $post_id;
	// Verify that the nonce is valid.
	$nonce = $_POST['expenses_items_metabox_nonce'];
	if ( ! wp_verify_nonce( $nonce, 'expenses_items_metabox' ) )
	    return $post_id;
	// If this is an autosave, our form has not been submitted, so we don't want to do anything.
	if ( defined( 'DOING_AUTOSAVE' ) && DOING_AUTOSAVE ) 
	    return $post_id;
	// Check the user's permissions.
	if ( 'page' == $_POST['post_type'] ) {
	    if ( ! current_user_can( 'edit_page', $post_id ) )
	        return $post_id;
	  	} else {
	    if ( ! current_user_can( 'edit_post', $post_id ) )
	        return $post_id;
	}
	$supplier = get_post_meta($post_id, 'supplier_id', true);
	$supplier_details = get_post_meta($supplier, 'supplier_details', true);
	$tax_name = isset($supplier_details['supplier_tax_name']) ? $supplier_details['supplier_tax_name'] : '';
	$stax_name = isset($supplier_details['supplier_stax_name']) ? $supplier_details['supplier_stax_name'] : '';	
	$tax_rate = get_post_meta($post_id, 'tax_rate', true);
	$stax_rate = get_post_meta($post_id, 'stax_rate', true);	
	$tax_applicable = get_post_meta($post_id, 'tax_applicable', true);
	$stax_applicable = get_post_meta($post_id, 'stax_applicable', true);
	$line_items = array();
	if(isset($_POST['group-a'])) {
		$items_to_add = $_POST['group-a'];
		$i = 0;
		foreach($items_to_add as $item) {
			$line_items[] = array(
				'qty' => $item['qty'],
				'desc' => $item['desc'],
				'price' => $item['price'],
				'sub' => $item['line_total'],
				'tax_ex' => $item['line_tax'][0],
				'stax_ex' => $item['line_stax'][0],
			);
			$i++;
		}
		update_post_meta($post_id, 'line_items', $line_items);
		$sub = isset($_POST['invoice_subtotal']) ? $_POST['invoice_subtotal'] : '';
		if(!empty($tax_rate)) {
			$tax = 0;
			foreach($items_to_add as $item) {
				if(empty($item['line_tax'][0])) {
					$amount = $item['line_total'];
					$tax_amount = $amount / 100 * $tax_rate;
					$tax = $tax + $tax_amount;
				}
			}
			if(!empty($stax_rate)) {
				$stax = 0;
				foreach($items_to_add as $item) {
					if(empty($item['line_stax'][0])) {
						$amount = $item['line_total'];
						$stax_amount = $amount / 100 * $stax_rate;
						$stax = $stax + $stax_amount;
					}
				}
				$total = $sub + $tax + $stax;
			} else {
				$stax = 0;
				$total = $sub + $tax;
			}
		} else {
			$tax = 0;
			$total = $sub;
		}
		$invoice_totals = array(
			'sub' => number_format((float)$sub, 2, '.', ''),
			'tax' => number_format((float)$tax, 2, '.', ''),
			'stax' => number_format((float)$stax, 2, '.', ''),
			'total' => number_format((float)$total, 2, '.', '')
		);
		update_post_meta($post_id, 'invoice_totals', $invoice_totals);
	} else {
		delete_post_meta($post_id, 'line_items');
		delete_post_meta($post_id, 'invoice_totals');
	}
}