<?php
add_action( 'add_meta_boxes', 'add_pto_expenses_cpt_metaboxes' );
function add_pto_expenses_cpt_metaboxes(){
	$screen = get_current_screen();
	$user = wp_get_current_user();
	if($screen->post_type == 'cqpim_expense') {
		global $post;
		$author = $post->post_author;
		if(current_user_can('cqpim_view_expenses_admin') || $user->ID == $author || current_user_can('cqpim_create_new_expense') && cqpim_is_edit_page('new')) {
			add_meta_box( 
				'expense_details', 
				__('Expense Details', 'cqpim-expenses'),
				'pto_expenses_details_metabox_callback', 
				'cqpim_expense', 
				'side',
				'high'
			);
			add_meta_box( 
				'expense_notes', 
				__('Expense Notes', 'cqpim-expenses'),
				'pto_expenses_notes_metabox_callback', 
				'cqpim_expense', 
				'normal'
			);
			add_meta_box( 
				'expense_line_items', 
				__('Expense Line Items', 'cqpim-expenses'),
				'pto_expenses_items_metabox_callback', 
				'cqpim_expense', 
				'normal',
				'high'
			);
			add_meta_box( 
				'expense_files', 
				__('Expense Files / Receipt', 'cqpim-expenses'),
				'pto_expenses_files_metabox_callback', 
				'cqpim_expense', 
				'normal',
				'high'
			);
		} else {
			add_meta_box( 
				'expense_denied', 
				__('Access Denied', 'cqpim'),
				'pto_expense_denied_metabox_callback', 
				'cqpim_expense',
				'normal'
			);	
			remove_meta_box( 'submitdiv', 'cqpim_expense', 'side' );				
		}
	}
}
require_once( 'access_denied.php' );
require_once( 'expenses_details.php' );
require_once( 'expenses_notes.php' );
require_once( 'expenses_items.php' );
require_once( 'expenses_files.php' );