<?php
add_action( 'add_meta_boxes', 'add_pto_suppliers_cpt_metaboxes' );
function add_pto_suppliers_cpt_metaboxes(){
	add_meta_box( 
		'supplier_details', 
		__('Supplier Details', 'cqpim-expenses'),
		'supplier_pto_details_metabox_callback', 
		'cqpim_supplier', 
		'normal',
		'high'
	);
	if(current_user_can('publish_cqpim_suppliers')) {
		add_meta_box( 
			'supplier_update', 
			__('Supplier Actions', 'cqpim-expenses'),
			'supplier_pto_update_metabox_callback', 
			'cqpim_supplier', 
			'side',
			'high'
		);
	}
	$currency_override = get_option('allow_supplier_currency_override');
	if(!empty($currency_override)) {
		add_meta_box( 
			'supplier_currency', 
			__('Supplier Currency', 'cqpim-expenses'),
			'supplier_pto_currency_metabox_callback', 
			'cqpim_supplier', 
			'side'
		);
	}
	add_meta_box( 
		'supplier_purchases', 
		__('Supplier Purchases', 'cqpim-expenses'),
		'supplier_pto_purchases_metabox_callback', 
		'cqpim_supplier', 
		'normal'
	);
}
require_once( 'supplier_update.php' );
require_once( 'supplier_currency.php' );
require_once( 'supplier_details.php' );
require_once( 'supplier_purchases.php' );