jQuery(document).ready(function() {
	
	jQuery('.datepicker').datepicker({ 

		showButtonPanel: true,
		closeText: localisation.calendar.closeText,
		currentText: localisation.calendar.currentText,
		monthNames: localisation.calendar.monthNames,
		monthNamesShort: localisation.calendar.monthNamesShort,
		dayNames: localisation.calendar.dayNames,
		dayNamesShort: localisation.calendar.dayNamesShort,
		dayNamesMin: localisation.calendar.dayNamesMin,
		dateFormat: localisation.calendar.dateFormat,
		firstDay: localisation.calendar.firstDay,	
	
	});	
	
	jQuery('#create_report').on('change', '#report_name', function(e) {
		
		if ( jQuery.fn.DataTable.isDataTable( '#results_table' ) ) {
		
			jQuery('#results_table').DataTable().destroy();
			
		}
		
		var sample = jQuery('#results_wrapper_sample').html();
		
		jQuery('#results_wrapper').html(sample);
		
		jQuery('#results_wrapper table').attr('id', 'results_table');
		
		var type = jQuery(this).val();
		
		var spinner = jQuery('#cqpim_overlay');
		
		var data = {
		
			'action' : 'pto_reporting_populate_item',
			
			'type' : type
		
		};
		
		jQuery.ajax({

			url: ajaxurl,

			data: data,

			type: 'POST',

			dataType: 'json',

			beforeSend: function(){

				// show spinner

				spinner.show();

			},

		}).done(function(response){
		
			if(response.error == true) {
			
				spinner.hide();
				
				jQuery('#report-messages').html(response.messages);
			
				jQuery('#report_item').html('');
				
				jQuery('#report_item_heading').html('');
				
				jQuery('#report_item').hide();
				
				jQuery('#report_item_heading').hide();
				
			} else {

				spinner.hide();
				
				if(response.item_cont == true) {
					
					jQuery('#report-messages').html('');

					jQuery('#report_item').html(response.options);
					
					jQuery('#report_item_heading').html(response.heading);
					
					jQuery('#report_item').show();
					
					jQuery('#report_item_heading').show();
				
				} 
				
				if(response.item_cont == false) {
					
					jQuery('#report-messages').html('');

					jQuery('#report_item').html('');
					
					jQuery('#report_item_heading').html('');
					
					jQuery('#report_item').hide();
					
					jQuery('#report_item_heading').hide();	
					
				}
			
			}

		});
		
	});
	
	// Run a report
	
	jQuery('#create_report').on('click', '#report-submit', function(e) {
		
		e.preventDefault();
		
		jQuery('#report-messages').html('');
		
		if ( jQuery.fn.DataTable.isDataTable( '#results_table' ) ) {
		
			jQuery('#results_table').DataTable().destroy();
			
		}
		
		var sample = jQuery('#results_wrapper_sample').html();
		
		jQuery('#results_wrapper').html(sample);
		
		jQuery('#results_wrapper table').attr('id', 'results_table');
		
		var type = jQuery('#report_name').val();
		
		var item = jQuery('#report_item').val();
		
		var start = jQuery('#start_date').val();
		
		var end = jQuery('#end_date').val();
		
		var rows = jQuery('#report_rows').val();
		
		var spinner = jQuery('#cqpim_overlay');
		
		var data = {
		
			'action' : 'pto_reporting_run_report',
			
			'type' : type,			
			
			'item' : item,
			
			'start' : start,
			
			'end' : end,
			
			'rows' : rows
		
		};
		
		jQuery.ajax({

			url: ajaxurl,

			data: data,

			type: 'POST',

			dataType: 'json',

			beforeSend: function(){

				// show spinner

				spinner.show();

			},

		}).always(function(response){
		
			console.log(response);
		
		}).done(function(response){
		
			if(response.error == true) {
			
				spinner.hide();
				
				jQuery('#report-messages').html(response.messages);
				
			} else {
				
				jQuery('#results_table thead tr').html(response.data.headers);
				
				jQuery('#results_table tbody').html(response.data.content);
				
				jQuery('#results_table tfoot tr').html(response.data.footer);
				
				jQuery('#results_table').dataTable({
					"pageLength": response.data.rows,
					"dom": 'Bfrtip',
					"buttons": [
						'copy', 'csv', 'excel', 'pdf', 'print'
					],
					"order": [[ response.data.sort, response.data.order ]],
					"language": {
						"processing":     localisation.datatables.sProcessing,
						"search":         localisation.datatables.sSearch,
						"lengthMenu":     localisation.datatables.sLengthMenu,
						"info":           localisation.datatables.sInfo,
						"infoEmpty":      localisation.datatables.sInfoEmpty,
						"infoFiltered":   localisation.datatables.sInfoFiltered,
						"infoPostFix":    localisation.datatables.sInfoPostFix,
						"loadingRecords": localisation.datatables.sLoadingRecords,
						"zeroRecords":    localisation.datatables.sZeroRecords,
						"emptyTable":     localisation.datatables.sEmptyTable,
						"paginate": {
							"first":      localisation.datatables.sFirst,
							"previous":   localisation.datatables.sPrevious,
							"next":       localisation.datatables.sNext,
							"last":       localisation.datatables.sLast
						},
						"aria": {
							"sortAscending":  localisation.datatables.sSortAscending,
							"sortDescending": localisation.datatables.sSortDescending
						}
					},
					"footerCallback": function ( row, data, start, end, display ) {
						var api = this.api(), data;
			 
						// Remove the formatting to get integer data for summation
						var intVal = function ( i ) {
							return typeof i === 'string' ?
								i.replace(/[^0-9\.]/g, '')*1 :
								typeof i === 'number' ?
									i : 0;
						};
			 
						// Total over all pages
						total = api
							.column( response.data.totals )
							.data()
							.reduce( function (a, b) {
								return intVal(a) + intVal(b);
							}, 0 );
			 
						// Total over this page
						pageTotal = api
							.column( response.data.totals, { page: 'current'} )
							.data()
							.reduce( function (a, b) {
								return intVal(a) + intVal(b);
							}, 0 );
			 
						// Update footer

						jQuery( api.column( response.data.totals ).footer() ).html(
							response.data.currency +pageTotal.toFixed(2) +' (' + response.data.currency + total.toFixed(2) +')'
						);
						
						if(response.data.totals2) {
							
							// Remove the formatting to get integer data for summation
							var intVal = function ( i ) {
								return typeof i === 'string' ?
									i.replace(/[^0-9\.]/g, '')*1 :
									typeof i === 'number' ?
										i : 0;
							};
				 
							// Total over all pages
							total = api
								.column( response.data.totals2 )
								.data()
								.reduce( function (a, b) {
									return intVal(a) + intVal(b);
								}, 0 );
				 
							// Total over this page
							pageTotal = api
								.column( response.data.totals2, { page: 'current'} )
								.data()
								.reduce( function (a, b) {
									return intVal(a) + intVal(b);
								}, 0 );
				 
							// Update footer

							jQuery( api.column( response.data.totals2 ).footer() ).html(
								response.data.currency +pageTotal.toFixed(2) +' (' + response.data.currency + total.toFixed(2) +')'
							);
						
						}
						
					},
				
				});
				
				spinner.hide();
			
			}

		});
		
	});
	
});