<?php
// REGISTER ALL ADMIN SCRIPTS
add_action( 'admin_enqueue_scripts', 'pto_reporting_register_all_admin_scripts' );
function pto_reporting_register_all_admin_scripts(){
	wp_register_script( 
		'reporting-jquery-ui',
		'https://code.jquery.com/ui/1.12.0/jquery-ui.min.js',
		array(),
		NULL,
		TRUE
	);
	wp_register_style( 
		'reporting-jquery-ui-styles', 
		'https://cdnjs.cloudflare.com/ajax/libs/jqueryui/1.12.1/jquery-ui.min.css',
		array(), 
		PTO_VERSION, 
		'all' 
	);
	wp_register_script( 
		'reporting-admin-ajax',
		plugin_dir_url(__FILE__)  . 'js/reporting-admin-ajax.js',
		array(),
		NULL,
		TRUE
	);
	wp_register_script( 
		'reporting-datatables',
		'https://cdn.datatables.net/1.10.16/js/jquery.dataTables.min.js',
		array(),
		NULL,
		TRUE
	);
	wp_register_script( 
		'reporting-datatables-buttons',
		'https://cdn.datatables.net/buttons/1.4.1/js/dataTables.buttons.min.js',
		array(),
		NULL,
		TRUE
	);
	wp_register_script( 
		'reporting-datatables-buttons-flash',
		'https://cdn.datatables.net/buttons/1.4.1/js/buttons.flash.min.js',
		array(),
		NULL,
		TRUE
	);
	wp_register_script( 
		'reporting-datatables-jszip',
		'https://cdnjs.cloudflare.com/ajax/libs/jszip/3.1.3/jszip.min.js',
		array(),
		NULL,
		TRUE
	);	
	wp_register_script( 
		'reporting-datatables-pdf',
		'https://cdnjs.cloudflare.com/ajax/libs/pdfmake/0.1.32/pdfmake.min.js',
		array(),
		NULL,
		TRUE
	);		
	wp_register_script( 
		'reporting-datatables-fonts',
		'https://cdnjs.cloudflare.com/ajax/libs/pdfmake/0.1.32/vfs_fonts.js',
		array(),
		NULL,
		TRUE
	);
	wp_register_script( 
		'reporting-datatables-butons-html5',
		'https://cdn.datatables.net/buttons/1.4.1/js/buttons.html5.min.js',
		array(),
		NULL,
		TRUE
	);
	wp_register_script( 
		'reporting-datatables-butons-print',
		'https://cdn.datatables.net/buttons/1.4.1/js/buttons.print.min.js',
		array(),
		NULL,
		TRUE
	);
	wp_register_style( 
		'reporting-datatables-styles', 
		'https://cdn.datatables.net/1.10.16/css/jquery.dataTables.min.css',
		array(), 
		PTO_VERSION, 
		'all' 
	);
	wp_register_style( 
		'pto_reporting_fontawesome', 
		'https://maxcdn.bootstrapcdn.com/font-awesome/4.7.0/css/font-awesome.min.css',
		array(), 
		PTO_VERSION, 
		'all' 
	);
}
function pto_enqueue_plugin_reporting_scripts() {
	add_action( 'admin_enqueue_scripts', 'pto_enqueue_plugin_reporting_scripts_now' );	
}
function pto_enqueue_plugin_reporting_scripts_now() {
	$scripts = array(
		'reporting-jquery-ui',
		'reporting-admin-ajax',
		'reporting-datatables',
		'reporting-datatables-buttons',
		'reporting-datatables-buttons-flash',
		'reporting-datatables-jszip',
		'reporting-datatables-pdf',
		'reporting-datatables-fonts',
		'reporting-datatables-butons-html5',
		'reporting-datatables-butons-print'
	);
	pto_custom_enqueue_scripts( $scripts );
	$styles = array(
		'pto_admin_styles',
		'reporting-jquery-ui-styles',
		'pto_reporting_fontawesome',
		'reporting-datatables-styles'
	);
	pto_custom_enqueue_styles( $styles );
}