<?php
if ( ! function_exists('pto_subscriptions_cpt') ) {
	function pto_subscriptions_cpt() {
		if(current_user_can('cqpim_create_new_subscription') && current_user_can('publish_cqpim_subscriptions')) {
			$form_caps = array();
		} else {
			$form_caps = array('create_posts' => false);
		}	
		$labels = array(
			'name'                => _x( 'Subscriptions', 'Post Type General Name', 'cqpim-subscriptions' ),
			'singular_name'       => _x( 'Subscription', 'Post Type Singular Name', 'cqpim-subscriptions' ),
			'menu_name'           => __( 'Subscriptions', 'cqpim-subscriptions' ),
			'parent_item_colon'   => __( 'Parent Subscription:', 'cqpim-subscriptions' ),
			'all_items'           => __( 'Subscriptions', 'cqpim-subscriptions' ),
			'view_item'           => __( 'View Subscription', 'cqpim-subscriptions' ),
			'add_new_item'        => __( 'Add New Subscription', 'cqpim-subscriptions' ),
			'add_new'             => __( 'New Subscription', 'cqpim-subscriptions' ),
			'edit_item'           => __( 'Edit Subscription', 'cqpim-subscriptions' ),
			'update_item'         => __( 'Update Subscription', 'cqpim-subscriptions' ),
			'search_items'        => __( 'Search Subscriptions', 'cqpim-subscriptions' ),
			'not_found'           => __( 'No Subscriptions found', 'cqpim-subscriptions' ),
			'not_found_in_trash'  => __( 'No Subscriptions found in trash', 'cqpim-subscriptions' ),
		);
		$args = array(
			'label'               => __( 'subscriptions', 'cqpim' ),
			'description'         => __( 'Subscriptions', 'cqpim' ),
			'labels'              => $labels,
			'supports'            => array( 'title' ),
			'hierarchical'        => false,
			'public'              => false,
			'show_ui'             => true,
			'show_in_nav_menus'   => false,
			'capabilities'        => $form_caps,			
			'show_in_menu'		  => false,
			'show_in_admin_bar'   => false,
			'menu_position'       => 5,
			'menu_icon'           => plugins_url() . "/img/contact.png",
			'can_export'          => true,
			'has_archive'         => false,
			'exclude_from_search' => true,
			'publicly_queryable'  => true,
			'capability_type'     => array('cqpim_subscription', 'cqpim_subscriptions'),
			'map_meta_cap'        => true,
			'query_var'			  => true,
			'rewrite'			  => array('slug' => get_option('cqpim_subs_slug')),
		);
		register_post_type( 'cqpim_subscription', $args );
	}
	add_action( 'init', 'pto_subscriptions_cpt', 18 );
}
	add_action( 'init', 'pto_subscription_cats', 0 );
	function pto_subscription_cats() {
		$labels = array(
			'name'              => __( 'Subscription Type', 'cqpim-subscriptions' ),
			'singular_name'     => __( 'Subscription Type', 'cqpim-subscriptions' ),
			'search_items'      => __( 'Search Subscription Types', 'cqpim-subscriptions' ),
			'all_items'         => __( 'All Subscription Types', 'cqpim-subscriptions' ),
			'parent_item'       => __( 'Parent Subscription Type', 'cqpim-subscriptions' ),
			'parent_item_colon' => __( 'Parent Subscription Type:', 'cqpim-subscriptions' ),
			'edit_item'         => __( 'Edit Subscription Type', 'cqpim-subscriptions' ),
			'update_item'       => __( 'Update Subscription Type', 'cqpim-subscriptions' ),
			'add_new_item'      => __( 'Add New Subscription Type', 'cqpim-subscriptions' ),
			'new_item_name'     => __( 'New Genre Subscription Type', 'cqpim-subscriptions' ),
			'menu_name'         => __( 'Subscription Types', 'cqpim-subscriptions' ),
		);
		$args = array(
			'hierarchical'      => true,
			'labels'            => $labels,
			'show_ui'           => true,
			'show_admin_column' => true,
			'query_var'         => true,
			'rewrite'           => false,
		);
		register_taxonomy( 'cqpim_subscription_cat', array( 'cqpim_subscription' ), $args );
	}
add_filter( 'bulk_actions-edit-cqpim_subscription', 'pto_remove_subscription_delete' );
function pto_remove_subscription_delete( $actions ){
	unset( $actions[ 'trash' ] );
	unset( $actions[ 'edit' ] );
	return $actions;
}