<?php
function pto_return_subs_text($type) {
	if($type == 'subs') {
		return __('Subscriptions', 'cqpim-subscriptions');
	} elseif($type == 'plans') {
		return __('Subscription Plans', 'cqpim-subscriptions');
	}
}
function pto_return_subs_cd_menu($client_dash) { ?>
	<li style="padding:10px"><?php _e('SUBSCRIPTIONS', 'cqpim-subscriptions'); ?></li>	
	<li class="link<?php if(!empty($_GET['page']) && $_GET['page'] == 'subscriptions' || is_singular('cqpim_subscription')) { echo ' active'; } ?>"><a href="<?php echo get_the_permalink($client_dash) . '?page=subscriptions'; ?>"><i class="fa fa-refresh" aria-hidden="true"></i><?php _e('Subscriptions', 'cqpim-subscriptions'); ?></a><span class="selected"></span></li>
	<li class="link<?php if(!empty($_GET['page']) && $_GET['page'] == 'subscription-plans' || is_singular('cqpim_plan')) { echo ' active'; } ?>"><a href="<?php echo get_the_permalink($client_dash) . '?page=subscription-plans'; ?>"><i class="fa fa-columns" aria-hidden="true"></i><?php _e('Subscription Plans', 'cqpim-subscriptions'); ?></a><span class="selected"></span></li>
<?php }
function pto_return_subs_cd_menu_fe($client_dash) { ?>
	<a href="<?php echo get_the_permalink($client_dash) . '?page=subscriptions'; ?>"><i class="fa fa-refresh" aria-hidden="true"></i><?php _e('Subscriptions', 'cqpim-subscriptions'); ?></a><span class="selected"></span>
	<a href="<?php echo get_the_permalink($client_dash) . '?page=subscription-plans'; ?>"><i class="fa fa-columns" aria-hidden="true"></i><?php _e('Subscription Plans', 'cqpim-subscriptions'); ?></a><span class="selected"></span>
<?php }
function pto_return_subs_page() { 
	$user = wp_get_current_user(); ?>
	<div class="cqpim_block_title">
		<div class="caption">
			<i class="fa fa-refresh font-green-sharp" aria-hidden="true"></i>
			<span class="caption-subject font-green-sharp sbold"> <?php _e('Subscriptions', 'cqpim-subscriptions'); ?></span>
		</div>
	</div>
	<br />
	<table class="datatable_style dataTable">
		<thead>
			<tr>
				<th><?php _e('ID', 'cqpim-subscriptions'); ?></th>
				<th><?php _e('Owner', 'cqpim-subscriptions'); ?></th>
				<th><?php _e('Title', 'cqpim-subscriptions'); ?></th>
				<th><?php _e('Last Charge', 'cqpim-subscriptions'); ?></th>
				<th><?php _e('Next Charge', 'cqpim-subscriptions'); ?></th>
				<th><?php _e('Status', 'cqpim-subscriptions'); ?></th>
			</tr>
		</thead>
		<tbody>
		<?php $args = array(
			'post_type' => 'cqpim_subscription',
			'posts_per_page' => -1,
			'post_status' => 'private',
			'meta_key' => 'subscription_client',
			'meta_value' => pto_get_client_from_userid($user),
		);
		$subs = get_posts($args);
		if(!empty($subs)) {
			foreach($subs as $sub) {
				$subscription_id = get_post_meta($sub->ID, 'subscription_id', true);
				$subscription_status = get_post_meta($sub->ID, 'subscription_status', true);
				$last_charge = get_post_meta($sub->ID, 'last_charge', true);
				$next_charge = get_post_meta($sub->ID, 'next_charge', true);
				$subscription_client_contact = get_post_meta($sub->ID, 'subscription_client_contact', true);
				$owner = get_user_by('id', $subscription_client_contact);
				?>
				<tr>
					<td><a href="<?php echo get_the_permalink($sub->ID); ?>"><?php echo $subscription_id; ?></a></td>
					<td><?php echo isset($owner->display_name) ? $owner->display_name : ''; ?></td>
					<td><a href="<?php echo get_the_permalink($sub->ID); ?>"><?php echo $sub->post_title; ?></a></td>
					<td><?php echo !empty($last_charge) ? date(get_option('cqpim_date_format'), $last_charge) : __('N/A', 'cqpim-subscriptions'); ?> <i class="fa fa-question-circle cqpim_tooltip" aria-hidden="true" title="<?php _e('This information will be available once the subscription has been activated.', 'cqpim-subscriptions'); ?>"></i></td>
					<td><?php echo !empty($next_charge) ? date(get_option('cqpim_date_format'), $next_charge) : __('N/A', 'cqpim-subscriptions'); ?> <i class="fa fa-question-circle cqpim_tooltip" aria-hidden="true" title="<?php _e('This information will be available once the subscription has been activated.', 'cqpim-subscriptions'); ?>"></i></td>
					<td><?php echo pto_return_subscription_status($subscription_status, true); ?></td>
				</tr>				
			<?php }
		}
		?>
		</tbody>
	</table>
<?php }
function pto_return_subscription_fe($post) {
	$post = get_post($post);
	$subscription_status = get_post_meta($post->ID, 'subscription_status', true);
	$tax_name = get_option('sales_tax_name');
	$stax_name = get_option('secondary_sales_tax_name');
	$tax_applicable = get_post_meta($post->ID, 'tax_applicable', true);
	$stax_applicable = get_post_meta($post->ID, 'stax_applicable', true); 
	$sub_item_type = get_post_meta($post->ID, 'sub_item_type', true); 
	$sub_plan = get_post_meta($post->ID, 'sub_plan', true);	
	if(!empty($sub_item_type) && $sub_item_type == 'plan') { 
		$line_items = get_post_meta($sub_plan, 'line_items', true);
		$totals = get_post_meta($sub_plan, 'invoice_totals', true);		
	} else {
		$line_items = get_post_meta($post->ID, 'line_items', true);
		$totals = get_post_meta($post->ID, 'invoice_totals', true);		
	}
	$sub = isset($totals['sub']) ? $totals['sub'] : '';
	$vat = isset($totals['tax']) ? $totals['tax'] : '';
	$svat = isset($totals['stax']) ? $totals['stax'] : '';
	$total = isset($totals['total']) ? $totals['total'] : '';	
	$vat_rate = get_post_meta($post->ID, 'tax_rate', true);
	$svat_rate = get_post_meta($post->ID, 'stax_rate', true);
	$subscription_gateway = get_post_meta($post->ID, 'subscription_gateway', true);
	if($subscription_gateway == 'stripe' && !empty($_POST['stripeEmail'])) { 
		pto_process_stripe_return($post->ID, $_POST);
	} elseif($subscription_gateway == 'paypal' && !empty($_GET['token'])) {
		pto_process_paypal_return($post->ID, $_GET['token']);
	} elseif($subscription_gateway == '2checkout' && !empty($_POST)) {
		pto_process_2checkout_return($post->ID, $_POST);
	}
	?>
	<div class="masonry-grid">
		<div class="grid-sizer"></div>
		<div class="cqpim-dash-item-triple grid-item">
			<div class="cqpim_block">
				<div class="cqpim_block_title">
					<div class="caption">
						<span class="caption-subject font-green-sharp sbold"><?php _e('Line Items', 'cqpim-subscriptions'); ?></span>
					</div>
				</div>
				<br />
				<table class="cqpim_table">
					<thead>
						<tr>
							<th><?php _e('Qty', 'cqpim-subscriptions'); ?></th>
							<th><?php _e('Description', 'cqpim-subscriptions'); ?></th>
							<th><?php _e('Rate', 'cqpim-subscriptions'); ?></th>
							<th><?php _e('Total', 'cqpim-subscriptions'); ?></th>
						</tr>
					</thead>
					<tbody>
					<?php 
					if(empty($line_items)) {
						$line_items = array();
					}				
					foreach($line_items as $item) { ?>
						<tr>
							<td><?php echo $item['qty']; ?></td>
							<td><?php echo $item['desc']; ?></td>
							<td><?php echo pto_calculate_currency($post->ID, $item['price']); ?></td>
							<td><?php echo pto_calculate_currency($post->ID, $item['sub']); ?></td>
						</tr>
					<?php } ?>
						<tr>
							<td colspan="3"><?php if($vat_rate) { ?><?php _e('Subtotal:', 'cqpim-subscriptions'); ?><?php } else { ?><?php _e('TOTAL:', 'cqpim-subscriptions'); ?><?php } ?></td>
							<td><?php echo pto_calculate_currency($post->ID, $sub); ?></td>
						</tr>
					<?php 
					$outstanding = $sub;
					if($vat_rate) { 
						$outstanding = $total;
						$tax_name = get_option('sales_tax_name'); ?>
						<tr>
							<td colspan="3"><?php echo $tax_name; ?>:</td>
							<td><?php echo pto_calculate_currency($post->ID, $vat); ?></td>
						</tr>
						<?php if(!empty($svat_rate)) { ?>
							<tr>
							<td colspan="3"><?php echo $stax_name; ?>:</td>
							<td><?php echo pto_calculate_currency($post->ID, $svat); ?></td>
							</tr>					
						<?php } ?>
						<tr>
							<td colspan="3"><?php _e('TOTAL:', 'cqpim-subscriptions'); ?></td>
							<td><?php echo pto_calculate_currency($post->ID, $total); ?></td>
						</tr>
					<?php } ?>
					</tbody>
				</table>
				<br />
				<div class="clear"></div>							
			</div>
		</div>
		<?php $subscription_invoice = get_post_meta($post->ID, 'subscription_invoice', true);
		if(!empty($subscription_invoice)) { ?>
			<div class="cqpim-dash-item-triple grid-item">
				<div class="cqpim_block">
					<div class="cqpim_block_title">
						<div class="caption">
							<span class="caption-subject font-green-sharp sbold"><?php _e('Subscription Invoices', 'cqpim-subscriptions'); ?> </span>
						</div>
					</div>
					<?php
					$user = wp_get_current_user();
					$args = array(
						'post_type' => 'cqpim_invoice',
						'posts_per_page' => -1,
						'post_status' => 'publish',
						'orderby' => 'date',
						'order' => 'DESC',
						'meta_key' => 'subscription_id',
						'meta_value' => $post->ID
					);
					$invoices = get_posts($args);
					if(empty($invoices)) { 
						echo '<p>' . __('This subscription does not have any invoices.', 'cqpim-subscriptions') . '</p>';
					} else {
						echo '<br /><table class="datatable_style dataTable">';
						echo '<thead>';
						echo '<tr><th>' . __('Invoice ID', 'cqpim') . '</th><th>' . __('Owner', 'cqpim') . '</th><th>' . __('Invoice Date', 'cqpim') . '</th><th>' . __('Amount', 'cqpim') . '</th><th>' . __('Status', 'cqpim') . '</th></tr>';
						echo '</thead>';
						echo '<tbody>';
						foreach($invoices as $invoice) {
							$invoice_id = get_post_meta($invoice->ID, 'invoice_id', true);
							$client_contact = get_post_meta($invoice->ID, 'client_contact', true);
							$owner = get_user_by('id', $client_contact);
							$invoice_details = get_post_meta($invoice->ID, 'invoice_details', true);
							$client_id = isset($invoice_details['client_id']) ? $invoice_details['client_id'] : '';
							$client_details = get_post_meta($client_id, 'client_details', true);
							$client_ids = get_post_meta($client_id, 'client_ids', true);
							$client_user_id = isset($client_details['user_id']) ? $client_details['user_id'] : '';
							$invoice_totals = get_post_meta($invoice->ID, 'invoice_totals', true);
							$tax_rate = get_option('sales_tax_rate');
							if(!empty($tax_rate)) {
								$total = isset($invoice_totals['total']) ? $invoice_totals['total'] : '';
							} else {
								$total = isset($invoice_totals['sub']) ? $invoice_totals['sub'] : '';
							}					
							$invoice_date = isset($invoice_details['invoice_date']) ? $invoice_details['invoice_date'] : '';
							if(is_numeric($invoice_date)) { $invoice_date = date(get_option('cqpim_date_format'), $invoice_date); } else { $invoice_date = $invoice_date; }
							$sent = isset($invoice_details['sent']) ? $invoice_details['sent'] : '';
							$paid = isset($invoice_details['paid']) ? $invoice_details['paid'] : '';
							$due = isset($invoice_details['terms_over']) ? $invoice_details['terms_over'] : '';
							$on_receipt = isset($invoice_details['on_receipt']) ? $invoice_details['on_receipt'] : '';
							$due = isset($invoice_details['terms_over']) ? $invoice_details['terms_over'] : '';
							if(empty($on_receipt)) {
								$due_readable = date(get_option('cqpim_date_format'), $due);
							} else {
								$due_readable = __('Due on Receipt', 'cqpim');
							}
							$current_date = time();
							$link = get_the_permalink($invoice->ID);
							$password = md5($invoice->post_password);
							$url = $link;
							if(!$paid) {
								if($current_date > $due) {
									if(empty($on_receipt)) {
										$status = '<span class="cqpim_button cqpim_small_button font-red border-red op nolink sbold"><strong>' . __('OVERDUE', 'cqpim') . '</strong></span>';
									} else {
										$status = '<span class="cqpim_button cqpim_small_button font-red border-red op nolink"><strong>' . __('Due on Receipt', 'cqpim') . '</strong></span>';
									}
								} else {
									if(!$sent) {
										$status = '<span class="cqpim_button cqpim_small_button font-red border-red op nolink">' . __('New', 'cqpim') . '</span>';
									} else {
										$status = '<span class="cqpim_button cqpim_small_button font-amber border-amber op nolink">' . __('Outstanding', 'cqpim') . '</span>';
									}
								}
							} else {
								$status = '<span class="cqpim_button cqpim_small_button font-green border-green op nolink">' . __('PAID', 'cqpim') . '</span>';
							}	
							if(!is_array($client_ids)) {
								$client_ids = array();
							}
							if($client_user_id == $user->ID && !empty($sent) || in_array($user->ID, $client_ids) && !empty($sent)) {
								echo '<tr>';
								echo '<td><span class="nodesktop"><strong>' . __('ID', 'cqpim') . '</strong>: </span> <a class="cqpim-link" href="' . $url . '" >' . $invoice_id . '</a></td>';
								echo '<td><span class="nodesktop"><strong>' . __('Owner', 'cqpim') . '</strong>: </span> ' . $owner->display_name . '</td>';
								echo '<td><span class="nodesktop"><strong>' . __('Date', 'cqpim') . '</strong>: </span> ' . $invoice_date . '</td>';
								echo '<td><span class="nodesktop"><strong>' . __('Amount', 'cqpim') . '</strong>: </span> ' . pto_calculate_currency($invoice->ID, $total) . '</td>';
								echo '<td><span class="nodesktop"><strong>' . __('Status', 'cqpim') . '</strong>: </span> ' . $status . '</td>';
								echo '</tr>';
							}
						}
						echo '</tbody>';
						echo '</table>';						
					} ?>
				</div>
			</div>
		<?php } ?>
		<div class="cqpim-dash-item-double grid-item">
			<div class="cqpim_block">
				<div class="cqpim_block_title">
					<div class="caption">
						<span class="caption-subject font-green-sharp sbold"><?php _e('Subscription Details', 'cqpim-subscriptions'); ?> </span>
					</div>
				</div>
				<br />
				<?php echo pto_return_subscription_status($subscription_status); 
				$subscription_id = get_post_meta($post->ID, 'subscription_id', true);
				$subscription_date = get_post_meta($post->ID, 'subscription_date', true);
				$subscription_gateway = get_post_meta($post->ID, 'subscription_gateway', true);
				$subscription_client = get_post_meta($post->ID, 'subscription_client', true);
				$subscription_client_contact = get_post_meta($post->ID, 'subscription_client_contact', true);
				$owner = get_user_by('id', $subscription_client_contact);
				$subscription_frequency = get_post_meta($post->ID, 'subscription_frequency', true);
				$subscription_start = get_post_meta($post->ID, 'subscription_start', true);
				$subscription_end = get_post_meta($post->ID, 'subscription_end', true);
				$last_charge = get_post_meta($post->ID, 'last_charge', true);
				$next_charge = get_post_meta($post->ID, 'next_charge', true);
				$last_amount = get_post_meta($post->ID, 'last_amount', true);
				$subscription_invoice = get_post_meta($post->ID, 'subscription_invoice', true);
				$subscription_gateway = get_post_meta($post->ID, 'subscription_gateway', true);
				$activated_info = get_post_meta($post->ID, 'activated_info', true);
				$activated_date = isset($activated_info['on']) ? date(get_option('cqpim_date_format'), $activated_info['on']) : __('Not Activated', 'cqpim-subscriptions');
				$cancelled_info = get_post_meta($post->ID, 'cancelled_info', true);
				$cancelled_date = isset($cancelled_info['on']) ? date(get_option('cqpim_date_format'), $cancelled_info['on']) : '';
				?>
				<p><strong><span><?php _e('Subscription ID:', 'cqpim-subscriptions'); ?></span></strong> <span><?php echo $subscription_id; ?></span></p>
				<p><strong><span><?php _e('Owner:', 'cqpim-subscriptions'); ?></span></strong> <span><?php echo isset($owner->display_name) ? $owner->display_name : ''; ?></span></p>
				<p><strong><span><?php _e('Start Date:', 'cqpim-subscriptions'); ?></span></strong> <span><?php echo !empty($subscription_start) ? date(get_option('cqpim_date_format'), $subscription_start) : __('On Activation', 'cqpim-subscriptions'); ?></span></p>
				<p><strong><span><?php _e('End Date:', 'cqpim-subscriptions'); ?></span></strong> <span><?php echo !empty($subscription_end) ? date(get_option('cqpim_date_format'), $subscription_end) : __('On Cancellation', 'cqpim-subscriptions'); ?></span></p>
				<p><strong><span><?php _e('Activation Date:', 'cqpim-subscriptions'); ?></span></strong> <span><?php echo $activated_date; ?></span></p>
				<?php if(!empty($cancelled_date)) { ?>
					<p><strong><span><?php _e('Cancellation Date:', 'cqpim-subscriptions'); ?></span></strong> <span><?php echo $cancelled_date; ?></span></p>
				<?php } ?>
				<p><strong><span><?php _e('Payment Frequency:', 'cqpim-subscriptions'); ?></span></strong> <span><?php echo pto_return_frequency_readable($subscription_frequency); ?></span></p>
				<p><strong><span><?php _e('Last Charge:', 'cqpim-subscriptions'); ?></span></strong> <span><?php echo !empty($last_charge) ? date(get_option('cqpim_date_format'), $last_charge) : __('N/A', 'cqpim-subscriptions') . ' <i class="fa fa-question-circle cqpim_tooltip" aria-hidden="true" title="' . __('This information will be available once the subscription has been activated.', 'cqpim-subscriptions') . '"></i>'; ?></span></p>
				<p><strong><span><?php _e('Next Charge:', 'cqpim-subscriptions'); ?></span></strong> <span><?php echo !empty($next_charge) ? date(get_option('cqpim_date_format'), $next_charge) : __('N/A', 'cqpim-subscriptions') . ' <i class="fa fa-question-circle cqpim_tooltip" aria-hidden="true" title="' . __('This information will be available once the subscription has been activated.', 'cqpim-subscriptions') . '"></i>'; ?></span></p>
				<p><strong><span><?php _e('Last Charge Amount:', 'cqpim-subscriptions'); ?></span></strong> <span><?php echo !empty($last_amount) ? pto_calculate_currency($post->ID, $last_amount) : __('N/A', 'cqpim-subscriptions') . ' <i class="fa fa-question-circle cqpim_tooltip" aria-hidden="true" title="' . __('This information will be available once the subscription has been activated.', 'cqpim-subscriptions') . '"></i>'; ?></span></p>
				<p><strong><span><?php _e('Payment Gateway:', 'cqpim-subscriptions'); ?></span></strong> <span><?php echo ucwords($subscription_gateway); ?></span></p>
				<div class="clear"></div>
				<?php
				$cancelled = get_post_meta($post->ID, 'cancelled', true);
				$cancelled_info = get_post_meta($post->ID, 'cancelled_info', true);
				$sent = get_post_meta($post->ID, 'sent', true);
				$sent_info = get_post_meta($post->ID, 'sent_info', true);
				$activated = get_post_meta($post->ID, 'activated', true);
				$activated_info = get_post_meta($post->ID, 'activated_info', true);
				$late = get_post_meta($post->ID, 'late', true);
				$subscription_status = get_post_meta($post->ID, 'subscription_status', true);								
				if(!empty($subscription_status) && $subscription_status == 'sent' || !empty($subscription_status) && $subscription_status == 'cancelled') {
					if($subscription_gateway == 'stripe') { 
						echo pto_return_stripe_activate($post->ID);
					} elseif($subscription_gateway == 'paypal') {
						echo pto_return_paypal_activate($post->ID);
					} elseif($subscription_gateway == '2checkout') {
						echo pto_return_2checkout_activate($post->ID);
					}
				}
				if(!empty($subscription_status) && $subscription_status == 'active' || !empty($subscription_status) && $subscription_status == 'late') {				
					if($subscription_gateway == 'stripe') { 
						echo pto_return_stripe_update($post->ID);
					} elseif($subscription_gateway == 'paypal') {
						echo pto_return_paypal_update($post->ID);
					} elseif($subscription_gateway == '2checkout') {
						echo pto_return_2checkout_update($post->ID);
					}
					echo pto_return_sub_cancel($post->ID); ?>
				<?php } ?>
			</div>		
		</div>	
<?php }
function pto_return_subs_plans_page() { ?>
	<div class="cqpim_block_title">
		<div class="caption">
			<i class="fa fa-columns font-green-sharp" aria-hidden="true"></i>
			<span class="caption-subject font-green-sharp sbold"> <?php _e('Subscription Plans', 'cqpim-subscriptions'); ?></span>
		</div>
	</div>
	<?php $args = array(
		'post_type' => 'cqpim_plan',
		'posts_per_page' => -1,
		'post_status' => 'private',
		'meta_key' => 'plan_show_cd',
		'meta_value' => 1	
	);
	$plans = get_posts($args);
	if(empty($plans)) {
		echo '<p>' . __('There are no plans that can be subscribed to', 'cqpim-subscriptions') . '</p>';	
	} else { ?>
	
		<div class="masonry-grid">
			<div class="grid-sizer"></div>
			<?php foreach($plans as $plan) { 
				$description = get_post_meta($plan->ID, 'plan_description', true); 
				$subscription_frequency = get_post_meta($plan->ID, 'subscription_frequency', true);
				$totals = get_post_meta($plan->ID, 'invoice_totals', true);
				$sub = isset($totals['sub']) ? $totals['sub'] : 0;
				$vat = isset($totals['tax']) ? $totals['tax'] : 0;
				$svat = isset($totals['stax']) ? $totals['stax'] : 0;
				$total = isset($totals['total']) ? $totals['total'] : 0; ?>
				<div class="cqpim-dash-item-full grid-item">
					<div class="cqpim_block" style="border:1px solid #eef1f5">
						<div class="cqpim_block_title">
							<div class="caption">
								<span class="caption-subject font-green-sharp sbold"><?php echo $plan->post_title; ?></span>
							</div>
						</div>
						<?php echo wpautop($description); ?>
						<p><strong><?php _e('Price:', 'cqpim-subscriptions'); ?> </strong><?php echo pto_calculate_currency($plan->ID, $total) . ' ' . pto_return_frequency_readable($subscription_frequency); ?></p>
						<button class="subscribe_to cqpim_button bg-blue font-white rounded_2" data-id="<?php echo $plan->ID; ?>"><?php _e('Subscribe', 'cqpim-subscriptions'); ?></button>
						<div id="subscribe-plan-div-container-<?php echo $plan->ID; ?>" style="display:none">
							<div id="subscribe-plan-div-<?php echo $plan->ID; ?>">
								<div style="padding:12px">
									<h3><?php _e('Subscribe to Plan', 'cqpim-subscriptions'); ?></h3>
									<?php echo '<p>' . __('Are you sure you want to subscribe to this plan?', 'cqpim-subscriptions') . '</p>'; ?>
									<button class="cancel-colorbox mt-10 cqpim_button font-red border-red op"><?php _e('Cancel', 'cqpim-subscriptions'); ?></button>								
									<button class="subscribe_confirm mt-10 cqpim_button font-green border-green right op" data-id="<?php echo $plan->ID; ?>"><?php _e('Subscribe', 'cqpim-subscriptions'); ?></button>								
								</div>
							</div>
						</div>	
					</div>
				</div>
			<?php } ?>
		</div>
	
	<?php } ?>

<?php }