<?php
function pto_return_stripe_activate($post) { 
	$post = get_post($post); 
	$subscription_id = get_post_meta($post->ID, 'subscription_id', true); 
	$subscription_client = get_post_meta($post->ID, 'subscription_client', true);
	$subscription_client_contact = get_post_meta($post->ID, 'subscription_client_contact', true);
	$client_contacts = get_post_meta($subscription_client, 'client_contacts', true);
	$client_details = get_post_meta($subscription_client, 'client_details', true);
	$client_main_id = isset($client_details['user_id']) ? $client_details['user_id'] : '';
	if(empty($client_contacts)) {
		$client_contacts = array();
	}
	if(!empty($subscription_client_contact)) {
		if($subscription_client_contact == $client_main_id) {
			$client_email = $client_details['client_email'];
		} else {
			$client_email = $client_contacts[$subscription_client_contact]['email'];
		}
	} else {
		$client_email = $client_details['client_email'];
	}
	$totals = get_post_meta($post->ID, 'invoice_totals', true);	
	$total = isset($totals['total']) ? $totals['total']: ''; ?>
	<form action="<?php echo get_the_permalink($post->ID); ?>" method="POST">
	  <script
		src="https://checkout.stripe.com/checkout.js" class="stripe-button"
		data-zip-code="true"
		data-locale="auto"
		data-email="<?php echo $client_email; ?>"
		data-label="<?php _e('Activate with Stripe', 'cqpim-subscriptions'); ?>"
		data-currency="<?php echo get_post_meta($post->ID, 'currency_code', true); ?>"
		data-allow-remember-me="false"
		data-key="<?php echo get_option('client_invoice_stripe_key'); ?>"
		data-name="<?php echo get_option('company_name'); ?>"
		data-description="<?php _e('Subscription ID', 'cqpim'); ?> #<?php echo $subscription_id; ?>">
		</script>
	</form>	
<?php }
function pto_return_stripe_update($post) { 
	$post = get_post($post); 
	$subscription_id = get_post_meta($post->ID, 'subscription_id', true); 
	$subscription_client = get_post_meta($post->ID, 'subscription_client', true);
	$subscription_client_contact = get_post_meta($post->ID, 'subscription_client_contact', true);
	$client_contacts = get_post_meta($subscription_client, 'client_contacts', true);
	$client_details = get_post_meta($subscription_client, 'client_details', true);
	$client_main_id = isset($client_details['user_id']) ? $client_details['user_id'] : '';
	if(empty($client_contacts)) {
		$client_contacts = array();
	}
	if(!empty($subscription_client_contact)) {
		if($subscription_client_contact == $client_main_id) {
			$client_email = $client_details['client_email'];
		} else {
			$client_email = $client_contacts[$subscription_client_contact]['email'];
		}
	} else {
		$client_email = $client_details['client_email'];
	}
	$totals = get_post_meta($post->ID, 'invoice_totals', true);	
	$total = isset($totals['total']) ? $totals['total']: ''; ?>
	<form action="<?php echo get_the_permalink($post->ID); ?>" method="POST">
	  <script
		src="https://checkout.stripe.com/checkout.js" class="stripe-button"
		data-zip-code="true"
		data-locale="auto"
		data-email="<?php echo $client_email; ?>"
		data-label="<?php _e('Update Card Details with Stripe', 'cqpim-subscriptions'); ?>"
		data-currency="<?php echo get_post_meta($post->ID, 'currency_code', true); ?>"
		data-allow-remember-me="false"
		data-key="<?php echo get_option('client_invoice_stripe_key'); ?>"
		data-name="<?php echo get_option('company_name'); ?>">
		</script>
	</form>	
<?php }
function pto_process_stripe_return($post, $data) {
	$post = get_post($post);
	require_once(PTO_SUBSCRIPTIONS_PATH . '/apis/stripe/init.php');
	\Stripe\Stripe::setApiKey(get_option('client_invoice_stripe_secret'));
	$user = get_user_by('email', $data['stripeEmail']);
	if(empty($user)) {
		echo '<div class="cqpim-alert cqpim-alert-danger alert-display">' . __('We could not activate this subscription due to missing data.', 'cqpim-subscriptions') . '</div>';
		return;
	}
	$client_id = pto_get_client_from_userid($user);
	if(!empty($client_id)) {
		if($client_id['type'] == 'admin') {
			$client_gw_ids = get_post_meta($client_id['assigned'], 'client_gw_ids', true);
		} else {
			$client_contacts = get_post_meta($client_id['assigned'], 'client_contacts', true);
			$client_gw_ids = isset($client_contacts[$user->ID]['client_gw_ids']) ? $client_contacts[$user->ID]['client_gw_ids'] : '';
		}
	} else {
		echo '<div class="cqpim-alert cqpim-alert-danger alert-display">' . __('We could not activate this subscription due to missing data.', 'cqpim-subscriptions') . '</div>';
		return;
	}
	$stripe_customer_id = isset($client_gw_ids['stripe']) ? $client_gw_ids['stripe'] : 0;
	if(!empty($stripe_customer_id)) {
		$customer_test = \Stripe\Customer::retrieve($stripe_customer_id);
	}
	if(empty($customer_test->id) || !empty($customer_test->deleted)) {
		$stripe_customer_id = '';
	}
	if(empty($stripe_customer_id)) {	
		$customer = \Stripe\Customer::create(array(
			"email" => $data['stripeEmail'],
			"source" => $data['stripeToken'],
		));
		if(empty($customer->id)) {
			echo '<div class="cqpim-alert cqpim-alert-danger alert-display">' . __('We could not save your details to Stripe, please try again.', 'cqpim-subscriptions') . '</div>';
			return;
		}
		$stripe_customer_id = $customer->id;
		if($client_id['type'] == 'admin') {
			$client_gw_ids = get_post_meta($client_id['assigned'], 'client_gw_ids', true);
			$client_gw_ids = $client_gw_ids && is_array($client_gw_ids) ? $client_gw_ids : array();
			$client_gw_ids['stripe'] = $customer->id;
			update_post_meta($client_id['assigned'], 'client_gw_ids', $client_gw_ids);
		} else {
			$client_contacts = get_post_meta($client_id['assigned'], 'client_contacts', true);
			$client_contacts = $client_contacts && is_array($client_contacts) ? $client_contacts : array();
			$client_contacts[$user->ID]['client_gw_ids']['stripe'] = $customer->id;
			update_post_meta($client_id['assigned'], 'client_contacts', $client_contacts);
		}
	} else {
		$cu = \Stripe\Customer::retrieve($stripe_customer_id);
		$cu->email = $data['stripeEmail'];
		$cu->source = $data['stripeToken'];
		$cu->save();
	}
	$subscription_start = get_post_meta($post->ID, 'subscription_start', true);
	$subscription_frequency = get_post_meta($post->ID, 'subscription_frequency', true);
	$frequency = pto_return_frequency_readable($subscription_frequency);
	$sub_item_type = get_post_meta($post->ID, 'sub_item_type', true); 
	$sub_plan = get_post_meta($post->ID, 'sub_plan', true);
	$next_charge = get_post_meta($post->ID, 'next_charge', true);
	if(!empty($sub_item_type) && $sub_item_type == 'plan') { 
		$totals = get_post_meta($sub_plan, 'invoice_totals', true);
		$total = isset($totals['total']) ? $totals['total'] : 0;
	} elseif(!empty($sub_item_type) && $sub_item_type == 'line') {
		$totals = get_post_meta($post->ID, 'invoice_totals', true);
		$total = isset($totals['total']) ? $totals['total'] : 0;		
	}
	$now = current_time('timestamp');
	if(empty($subscription_start) && empty($next_charge) || !empty($subscription_start) && $now > $subscription_start && empty($next_charge)) {		
		try {		
			$charge = \Stripe\Charge::create(array(
				"amount" => $total * 100,
				"currency" => get_post_meta($post->ID, 'currency_code', true),
				"customer" => $stripe_customer_id,
				"description" => __('Subscription', 'cqpim-subscriptions') . ': ' . $post->post_title)
			);
		} catch(\Stripe\Error\Card $e) {
			$stripe_response = json_decode($e->httpBody);
			$stripe_error = $stripe_response->error;
		}
		if(!empty($stripe_error->code)) {
			$payment_error = true;
			$error_message = $stripe_error->message;
			echo '<div class="cqpim-alert cqpim-alert-danger alert-display">' . sprintf(__('Your payment didn\'t go through. Error: %1$s', 'cqpim-subscriptions'), $error_message) . '</div>';
			return;
		} else {
			$args = array(
				'post_type' => 'cqpim_teams',
				'posts_per_page' => -1,
				'post_status' => 'private'
			);
			$teams = get_posts($args);			
			foreach($teams as $team) {
				$team_details = get_post_meta($team->ID, 'team_details', true);
				$user_id = isset($team_details['user_id']) ? $team_details['user_id'] : '';
				if(!empty($user_id)) {
					$user_obj = get_user_by('id', $user_id);
					if(user_can($user_obj, 'edit_cqpim_subscriptions')) {
						pto_add_team_notification($team->ID, $user->ID, $post->ID, 'subscription_activated');
					}
				}
			}
			$payment_processed = true;
			update_post_meta($post->ID, 'last_charge', current_time('timestamp'));
			update_post_meta($post->ID, 'last_amount', $total);
			update_post_meta($post->ID, 'next_charge', pto_calculate_next_charge($post->ID));
			update_post_meta($post->ID, 'rem_1_sent', true);
			update_post_meta($post->ID, 'rem_2_sent', true);
		}
	} elseif(empty($next_charge)) {
		echo '<div class="cqpim-alert cqpim-alert-success alert-display">' . sprintf(__('Your card details have been saved to Stripe. You will be charged %1$s from %2$s', 'cqpim-subscriptions'), $frequency, date(get_option('cqpim_date_format'), $subscription_start)) . '</div>';
		update_post_meta($post->ID, 'next_charge', $subscription_start);
		return;
	}
	$activated = get_post_meta($post->ID, 'activated', true);
	if(empty($activated)) {
		update_post_meta($post->ID, 'cancelled', '');
		update_post_meta($post->ID, 'cancelled_info', '');
		update_post_meta($post->ID, 'activated', true);
		update_post_meta($post->ID, 'activated_info', array('by' => $user->ID, 'on' => current_time('timestamp')));
		update_post_meta($post->ID, 'subscription_status', 'active');
		pto_send_activation_mail($post->ID);
		$subscription_invoice = get_post_meta($post->ID, 'subscription_invoice', true);
		if(!empty($subscription_invoice) && $payment_processed == true) {
			$invoice_pid = pto_create_sub_invoice($post->ID);
			pto_mark_invoice_paid($invoice_pid, 'Stripe', $total);
			$auto_invoice = get_option('auto_send_invoices');
			if($auto_invoice) {
				pto_process_invoice_emails($invoice_pid);
			}	
		}
	} ?>
	<script>	
		var url = '<?php echo get_the_permalink($post->ID); ?>';	
		window.location.replace(url);
	</script>
	<?php return;
}
function pto_process_stripe_payment($post) {
	$post = get_post($post);
	$subscription_start = get_post_meta($post->ID, 'subscription_start', true);
	$subscription_gateway = get_post_meta($post->ID, 'subscription_gateway', true);
	$subscription_end = get_post_meta($post->ID, 'subscription_end', true);
	$subscription_frequency = get_post_meta($post->ID, 'subscription_frequency', true);
	$frequency = pto_return_frequency_readable($subscription_frequency);
	$sub_item_type = get_post_meta($post->ID, 'sub_item_type', true); 
	$sub_plan = get_post_meta($post->ID, 'sub_plan', true);
	$next_charge = get_post_meta($post->ID, 'next_charge', true);
	if(!empty($sub_item_type) && $sub_item_type == 'plan') { 
		$totals = get_post_meta($sub_plan, 'invoice_totals', true);
		$total = isset($totals['total']) ? $totals['total'] : 0;
	} elseif(!empty($sub_item_type) && $sub_item_type == 'line') {
		$totals = get_post_meta($post->ID, 'invoice_totals', true);
		$total = isset($totals['total']) ? $totals['total'] : 0;		
	}
	require_once(PTO_SUBSCRIPTIONS_PATH . '/apis/stripe/init.php');
	\Stripe\Stripe::setApiKey(get_option('client_invoice_stripe_secret'));	
	$user = get_post_meta($post->ID, 'subscription_client_contact', true);
	$user = get_user_by('id', $user);
	$client_id = pto_get_client_from_userid($user);
	if(!empty($client_id)) {
		if($client_id['type'] == 'admin') {
			$client_gw_ids = get_post_meta($client_id['assigned'], 'client_gw_ids', true);
		} else {
			$client_contacts = get_post_meta($client_id['assigned'], 'client_contacts', true);
			$client_gw_ids = isset($client_contacts[$user->ID]['client_gw_ids']) ? $client_contacts[$user->ID]['client_gw_ids'] : '';
		}
	} else {
		return;
	}
	$stripe_customer_id = isset($client_gw_ids['stripe']) ? $client_gw_ids['stripe'] : '';
	$customer_test = \Stripe\Customer::retrieve($stripe_customer_id);
	if(empty($customer_test->id) || !empty($customer_test->deleted)) {
		$stripe_customer_id = '';
	}	
	try {		
		$charge = \Stripe\Charge::create(array(
			"amount" => $total * 100,
			"currency" => get_post_meta($post->ID, 'currency_code', true),
			"customer" => $stripe_customer_id,
			"description" => __('Subscription', 'cqpim-subscriptions') . ': ' . $post->post_title)
		);
	} catch(\Stripe\Error\Card $e) {
		$stripe_response = json_decode($e->httpBody);
		$stripe_error = $stripe_response->error;
	}
	if(!empty($stripe_error->code)) {
		$args = array(
			'post_type' => 'cqpim_teams',
			'posts_per_page' => -1,
			'post_status' => 'private'
		);
		$teams = get_posts($args);			
		foreach($teams as $team) {
			$team_details = get_post_meta($team->ID, 'team_details', true);
			$user_id = isset($team_details['user_id']) ? $team_details['user_id'] : '';
			if(!empty($user_id)) {
				$user = get_user_by('id', $user_id);
				if(user_can($user, 'edit_cqpim_subscriptions')) {
					pto_add_team_notification($team->ID, 'system', $post->ID, 'subscription_failed');
					
				}
			}
		}
		update_post_meta($post->ID, 'subscription_status', 'late');
		pto_subs_send_failed_mail();
		pto_add_team_notification($client_id, 'system', $post->ID, 'subscription_failed');
	} else {
		$args = array(
			'post_type' => 'cqpim_teams',
			'posts_per_page' => -1,
			'post_status' => 'private'
		);
		$teams = get_posts($args);			
		foreach($teams as $team) {
			$team_details = get_post_meta($team->ID, 'team_details', true);
			$user_id = isset($team_details['user_id']) ? $team_details['user_id'] : '';
			if(!empty($user_id)) {
				$user = get_user_by('id', $user_id);
				if(user_can($user, 'edit_cqpim_subscriptions')) {
					pto_add_team_notification($team->ID, 'system', $post->ID, 'subscription_renewed');
				}
			}
		}
		$payment_processed = true;
		update_post_meta($post->ID, 'last_charge', current_time('timestamp'));
		update_post_meta($post->ID, 'last_amount', $total);
		update_post_meta($post->ID, 'next_charge', pto_calculate_next_charge($post->ID));
		update_post_meta($post->ID, 'rem_1_sent', false);
		update_post_meta($post->ID, 'rem_2_sent', false);
		pto_add_team_notification($client_id, 'system', $post->ID, 'subscription_renewed');
	}
	$subscription_invoice = get_post_meta($post->ID, 'subscription_invoice', true);
	if(!empty($subscription_invoice)) {
		$invoice_pid = pto_create_sub_invoice($post->ID);
		if(!empty($payment_processed)) {
			pto_mark_invoice_paid($invoice_pid, 'Stripe', $total);
		}
		$auto_invoice = get_option('auto_send_invoices');
		if($auto_invoice) {
			pto_process_invoice_emails($invoice_pid);
		}	
	}
	return;
}