<?php
function pto_plan_details_metabox_callback( $post ) {
 	wp_nonce_field( 
 	 	'plan_details_metabox', 
 	 	'plan_details_metabox_nonce' ); 
		$description = get_post_meta($post->ID, 'plan_description', true);
		$show_cd = get_post_meta($post->ID, 'plan_show_cd', true);
		$subscription_frequency = get_post_meta($post->ID, 'subscription_frequency', true);
		$subscription_gateway = get_post_meta($post->ID, 'subscription_gateway', true);
		?>
		<p><strong><?php _e('Description', 'cqpim-subscriptions'); ?></strong></p>
		<textarea style="height:150px" name="description" id="description" required><?php echo $description?$description:''; ?></textarea>
		<br /><br />
		<input type="checkbox" name="show_cd" id="show_cd" value="1" <?php checked($show_cd, 1); ?> /> <?php _e('Show this plan in the client dashboard', 'cqpim-subscriptions'); ?>
		<i class="fa fa-question-circle cqpim_tooltip" aria-hidden="true" title="<?php _e('Selecting this will show this plan in the client dashboard where clients can sign up to it at any time.', 'cqpim-subscriptions'); ?>"></i>
		<br />
		<p><?php _e('Billing Frequency:', 'cqpim-subscriptions'); ?> <i class="fa fa-question-circle cqpim_tooltip" aria-hidden="true" title="<?php _e('This can be overriden on the subscription if required.', 'cqpim-subscriptions'); ?>"></i></p>
		<select id="subscription_frequency" name="subscription_frequency" required>
			<option value="0" <?php selected($subscription_frequency, 0); ?>><?php _e('Select a frequency', 'cqpim-subscriptions'); ?></option>
			<option value="day" <?php selected($subscription_frequency, 'day'); ?>><?php _e('Daily', 'cqpim-subscriptions'); ?></option>
			<option value="week" <?php selected($subscription_frequency, 'week'); ?>><?php _e('Weekly', 'cqpim-subscriptions'); ?></option>
			<option value="biweek" <?php selected($subscription_frequency, 'biweek'); ?>><?php _e('Every Two Weeks', 'cqpim-subscriptions'); ?></option>
			<option value="month" <?php selected($subscription_frequency, 'month'); ?>><?php _e('Monthly', 'cqpim-subscriptions'); ?></option>
			<option value="bimonth" <?php selected($subscription_frequency, 'bimonth'); ?>><?php _e('Every Two Months', 'cqpim-subscriptions'); ?></option>
			<option value="trimonth" <?php selected($subscription_frequency, 'trimonth'); ?>><?php _e('Every Three Months', 'cqpim-subscriptions'); ?></option>
			<option value="sixmonth" <?php selected($subscription_frequency, 'sixmonth'); ?>><?php _e('Every 6 Months', 'cqpim-subscriptions'); ?></option>
			<option value="year" <?php selected($subscription_frequency, 'year'); ?>><?php _e('Yearly', 'cqpim-subscriptions'); ?></option>
			<option value="biyear" <?php selected($subscription_frequency, 'biyear'); ?>><?php _e('Every Two Years', 'cqpim-subscriptions'); ?></option>
		</select>		
		<br />
		<?php echo '<p>' . __('Payment Gateway:', 'cqpim-subscriptions') . ' </p>';
		$gateways = pto_check_gateway_config();
		if(!empty($gateways)) {
			echo '<select name="subscription_gateway" id="subscription_gateway" required>';
				echo '<option value="">' . __('Choose a gateway...', 'cqpim-subscriptions') . '</option>';
				foreach($gateways as $gateway) {
					echo '<option value="' . $gateway['id'] . '" ' . selected($gateway['id'], $subscription_gateway) . '>' . $gateway['name'] . '</option>';
				}
			echo '</select>';
		} else {
			echo '<div class="cqpim-alert cqpim-alert-warning alert-display">';
				_e('You do not have any Payment Gateways configured for subscriptions. Set one up in the plugin settings.', 'cqpim-subscriptions');
			echo '</div>';				
		} ?>
		<br /><br />
		<?php if(current_user_can('publish_cqpim_plans')) { ?>
			<a class="save cqpim_button cqpim_button_link font-white bg-blue rounded_2 block" href="#"><?php _e('Update Subscription Plan', 'cqpim-subscriptions'); ?></a>
		<?php } ?>
		<?php if(current_user_can('delete_cqpim_plans')) { ?>
			<a class="delete_plan cqpim_button cqpim_button_link font-white bg-red rounded_2 block mt-10" href="#"><?php _e('Delete Subscription Plan', 'cqpim-subscriptions'); ?></a>
		<?php } ?>
		<div id="delete-plan-div-container" style="display:none">
			<div id="delete-plan-div">
				<div style="padding:12px">
					<h3><?php _e('Delete Subscription Plan', 'cqpim-subscriptions'); ?></h3>
					<?php $args = array(
						'post_type' => 'cqpim_subscription',
						'posts_per_page' => -1,
						'post_status' => 'private',
						'meta_key' => 'sub_plan',
						'meta_value' => $post->ID
					);
					$subs = get_posts($args);
					if(empty($subs)) {
						echo '<p>' . __('Are you sure you want to delete this plan?', 'cqpim-subscriptions') . '</p>';
					} else {
						echo '<p>' . __('You cannot delete this plan because there are subscriptions that use it. You should reassign those subscriptions before deleting this plan', 'cqpim-subscriptions') . '</p>';
					} ?>
					<a class="cancel-colorbox mt-10 cqpim_button font-red border-red op" href="#"><?php _e('Cancel', 'cqpim-subscriptions'); ?></a>
					<?php if(empty($subs)) { ?>
						<button id="delete_task_confirm" data-id="<?php echo $post->ID; ?>" class="mt-10 cqpim_button font-green border-green right op"><?php _e('Delete Plan', 'cqpim-subscriptions'); ?></button>
					<?php } ?>
				</div>
			</div>
		</div>
		<?php
}
add_action( 'save_post', 'save_pto_plan_details_metabox_data' );
function save_pto_plan_details_metabox_data( $post_id ){
	if ( ! isset( $_POST['plan_details_metabox_nonce'] ) )
	    return $post_id;
	$nonce = $_POST['plan_details_metabox_nonce'];
	if ( ! wp_verify_nonce( $nonce, 'plan_details_metabox' ) )
	    return $post_id;
	if ( defined( 'DOING_AUTOSAVE' ) && DOING_AUTOSAVE ) 
	    return $post_id;
	if ( 'page' == $_POST['post_type'] ) {
	    if ( ! current_user_can( 'edit_page', $post_id ) )
	        return $post_id;
	  	} else {
	    if ( ! current_user_can( 'edit_post', $post_id ) )
	        return $post_id;
	}
	if(isset($_POST['description'])) {
		update_post_meta($post_id, 'plan_description', $_POST['description']);
	}
	if(!empty($_POST['show_cd'])) {
		update_post_meta($post_id, 'plan_show_cd', 1);
	} else {
		update_post_meta($post_id, 'plan_show_cd', 0);
	}
	if(isset($_POST['subscription_frequency'])) {
		update_post_meta($post_id, 'subscription_frequency', $_POST['subscription_frequency']);
	}
	if(isset($_POST['subscription_gateway'])) {
		update_post_meta($post_id, 'subscription_gateway', $_POST['subscription_gateway']);
	}
	$currency = get_option('currency_symbol');
	$currency_code = get_option('currency_code');
	$currency_position = get_option('currency_symbol_position');
	$currency_space = get_option('currency_symbol_space');
	update_post_meta($post_id, 'currency_symbol', $currency);
	update_post_meta($post_id, 'currency_code', $currency_code);
	update_post_meta($post_id, 'currency_space', $currency_space);
	update_post_meta($post_id, 'currency_position', $currency_position);
	$tax_app = get_post_meta($post_id, 'tax_set', true);
	if(empty($tax_app)) {
		$system_tax = get_option('sales_tax_rate');
		$system_stax = get_option('secondary_sales_tax_rate');
		if(!empty($system_tax)) {
			update_post_meta($post_id, 'tax_applicable', 1);
			update_post_meta($post_id, 'tax_set', 1);	
			update_post_meta($post_id, 'tax_rate', $system_tax);	
			if(!empty($system_stax)) {
				update_post_meta($post_id, 'stax_applicable', 1);
				update_post_meta($post_id, 'stax_set', 1);	
				update_post_meta($post_id, 'stax_rate', $system_stax);			
			} else {
				update_post_meta($post_id, 'stax_applicable', 0);
				update_post_meta($post_id, 'stax_set', 1);
				update_post_meta($post_id, 'stax_rate', 0);				
			}
		} else {
			update_post_meta($post_id, 'tax_applicable', 0);
			update_post_meta($post_id, 'tax_set', 1);
			update_post_meta($post_id, 'tax_rate', 0);			
		}
	}
}