<?php
function pto_subscription_status_metabox_callback( $post ) {
 	wp_nonce_field( 
 	 	'subscription_status_metabox', 
 	 	'subscription_status_metabox_nonce' ); 
		$subscription_status = get_post_meta($post->ID, 'subscription_status', true);
		$last_charge = get_post_meta($post->ID, 'last_charge', true);
		$next_charge = get_post_meta($post->ID, 'next_charge', true);
		$last_amount = get_post_meta($post->ID, 'last_amount', true);
		echo pto_return_subscription_status($subscription_status);
		$cancelled = get_post_meta($post->ID, 'cancelled', true);
		$cancelled_info = get_post_meta($post->ID, 'cancelled_info', true);
		$sent = get_post_meta($post->ID, 'sent', true);
		$sent_info = get_post_meta($post->ID, 'sent_info', true);
		$activated = get_post_meta($post->ID, 'activated', true);
		$activated_info = get_post_meta($post->ID, 'activated_info', true);
		$late = get_post_meta($post->ID, 'late', true);
		?>
		<div class="sub_stats">		
			<div class="cqpim_block">
				<div class="cqpim_block_title">
					<div class="caption">
						<i class="fa fa-credit-card-alt font-green-sharp" aria-hidden="true"></i>
						<span class="caption-subject font-green-sharp sbold"><?php _e('Last Charge', 'cqpim-subscriptions'); ?></span>
					</div>
				</div>
				<div class="cqpim_sub_block_content"><?php echo !empty($last_charge) ? date(get_option('cqpim_date_format'), $last_charge) : __('N/A', 'cqpim-subscriptions') . ' <i class="fa fa-question-circle cqpim_tooltip" aria-hidden="true" title="' . __('This information will be available once the subscription has been activated.', 'cqpim-subscriptions') . '"></i>'; ?></div>
			</div>
		</div>
		<div class="sub_stats">
			<div class="cqpim_block">
				<div class="cqpim_block_title">
					<div class="caption">
						<i class="fa fa-credit-card-alt font-green-sharp" aria-hidden="true"></i>
						<span class="caption-subject font-green-sharp sbold"><?php _e('Next Charge', 'cqpim-subscriptions'); ?></span>
					</div>
				</div>
				<div class="cqpim_sub_block_content"><?php echo !empty($next_charge) ? date(get_option('cqpim_date_format'), $next_charge) : __('N/A', 'cqpim-subscriptions') . ' <i class="fa fa-question-circle cqpim_tooltip" aria-hidden="true" title="' . __('This information will be available once the subscription has been activated.', 'cqpim-subscriptions') . '"></i>'; ?></div>
			</div>
		</div>
		<div class="sub_stats last">
			<h3></h3>
			<div class="cqpim_block">
				<div class="cqpim_block_title">
					<div class="caption">
						<i class="fa fa-credit-card-alt font-green-sharp" aria-hidden="true"></i>
						<span class="caption-subject font-green-sharp sbold"><?php _e('Last Charge Amount', 'cqpim-subscriptions'); ?></span>
					</div>
				</div>
				<div class="cqpim_sub_block_content"><?php echo !empty($last_amount) ? pto_calculate_currency($post->ID, $last_amount) : __('N/A', 'cqpim-subscriptions') . ' <i class="fa fa-question-circle cqpim_tooltip" aria-hidden="true" title="' . __('This information will be available once the subscription has been activated.', 'cqpim-subscriptions') . '"></i>'; ?></div>
			</div>
		</div>
		<div class="clear"></div>
		<?php if(!empty($cancelled)) { ?>
			<div class="cqpim-alert cqpim-alert-danger">
				<?php printf(__('This subscription was cancelled by %1$s on %2$s', 'cqpim-subscriptions'), pto_return_user_display($cancelled_info['by']), date(get_option('cqpim_date_format') . ' H:i:s', $cancelled_info['on'])); ?>
			</div>
		<?php } else { ?>
			<?php if(!empty($activated)) { ?>
				<div class="cqpim-alert cqpim-alert-success">
					<?php printf(__('This subscription was activated by %1$s on %2$s', 'cqpim-subscriptions'), pto_return_user_display($activated_info['by']), date(get_option('cqpim_date_format') . ' H:i:s', $activated_info['on'])); ?>
				</div>				
			<?php } else { ?>
				<?php if(!empty($sent)) { ?>
					<div class="cqpim-alert cqpim-alert-warning">
						<?php printf(__('This subscription was sent to %1$s by %2$s on %3$s', 'cqpim-subscriptions'), $sent_info['to'], $sent_info['by'], date(get_option('cqpim_date_format') . ' H:i:s', $sent_info['on'])); ?>
					</div>						
				<?php } else { ?>
					<div class="cqpim-alert cqpim-alert-warning">
						<?php _e('This subscription has not been sent for activation approval', 'cqpim-subscriptions'); ?>
					</div>					
				<?php } ?>
			<?php } ?>		
		<?php } ?>
		<div class="clear"></div>
		<?php if(empty($activated)) { ?>
			<a id="send_subscription" class="mt-20 cqpim_button bg-blue font-white right rounded_4"><?php _e('Send Subscription', 'cqpim'); ?></a>
		<?php } ?>
		<?php if(empty($cancelled) && !empty($activated)) { ?>
			<a id="cancel_subscription" class="mt-20 cqpim_button bg-red font-white right rounded_4"><?php _e('Cancel Subscription', 'cqpim'); ?></a>
			<div id="invoice_payment_container" style="display:none">
				<div id="invoice_payment">
					<div style="padding:12px">
						<h3><?php _e('Cancel Subscription', 'cqpim-subscriptions'); ?></h3>
						<p><?php _e('Are you sure you want to cancel this subscription?', 'cqpim-subscriptions'); ?></p>
						<div class="clear"></div>
						<a class="cancel-colorbox mt-10 cqpim_button font-red border-red op" href="#"><?php _e('Cancel', 'cqpim-subscriptions'); ?></a>
						<?php echo '<button class="cqpim_button font-green border-green mt-10 right op" id="cancel_sub_conf" data-id="' . $post->ID . '">' . __('Confirm', 'cqpim-subscriptions') . '</button>'; ?>								
						<div class="clear"></div>
						<br />
					</div>
				</div>
			</div>
		<?php } ?>
		<div class="clear"></div>
		<div id="status_messages"></div>
	<?php
}
add_action( 'save_post', 'save_pto_subscription_status_metabox_data' );
function save_pto_subscription_status_metabox_data( $post_id ){
	if ( ! isset( $_POST['subscription_status_metabox_nonce'] ) )
	    return $post_id;
	$nonce = $_POST['subscription_status_metabox_nonce'];
	if ( ! wp_verify_nonce( $nonce, 'subscription_status_metabox' ) )
	    return $post_id;
	if ( defined( 'DOING_AUTOSAVE' ) && DOING_AUTOSAVE ) 
	    return $post_id;
	if ( 'page' == $_POST['post_type'] ) {
	    if ( ! current_user_can( 'edit_page', $post_id ) )
	        return $post_id;
	  	} else {
	    if ( ! current_user_can( 'edit_post', $post_id ) )
	        return $post_id;
	}

}