<?php
/**
* Plugin Name: Projectopia - Subscriptions Add-On
* Description: The Projectopia Subscriptions Plugin is ad add-on for Projectopia Core that allows You to set up auto-billing subscriptions
* Version: 1.0.4
* Author: Projectopia
* Author URI: http://projectopia.io
* Text Domain: cqpim-expenses
* Domain Path: /languages
*/
define('PTO_SUBSCRIPTIONS_VERSION', '1.0.4');
// Paths
define('PTO_SUBSCRIPTIONS_PATH', plugin_dir_path( __FILE__ ));
define('PTO_SUBSCRIPTIONS_DIRNAME', basename( plugin_basename( PTO_SUBSCRIPTIONS_PATH ) ));
define('PTO_SUBSCRIPTIONS_PLUGIN_URL', plugins_url() . '/' . PTO_SUBSCRIPTIONS_DIRNAME);
// Languages
function pto_subscriptions_plugin_setup() {
	load_plugin_textdomain('cqpim-subscriptions', false, dirname(plugin_basename(__FILE__)) . '/languages/');
} 
add_action('plugins_loaded', 'pto_subscriptions_plugin_setup');
register_activation_hook( __FILE__, 'pto_subscriptions_activation' );
function pto_subscriptions_activation() {
	if(is_plugin_active(PTO_DIRNAME . '/projectopia.php')) {
		$cqpim_version = PTO_VERSION;
		if($cqpim_version < '4.0.3') {
			$message = __('You need to have at least version 4.0.3 of the Projectopia Core plugin installed to use this add-on', 'cqpim-subscriptions');
			wp_die($message, 'Projectopia Core Plugin Version Problem');				
		} else {
			$client_role = get_role('cqpim_client');
			if(!empty($client_role)) {
				$client_role->add_cap('read_private_cqpim_subscriptions');
			}
			update_option('cqpim_subs_slug', 'pto_subscription');
			update_option('cqpim_new_subscription_subject', '%%CURRENT_USER%% has sent you a new Subscription (%%SUBSCRIPTION_ID%%)');
			$text = 'Dear %%CLIENT_NAME%%

%%CURRENT_USER%% has created a new subscription.

%%SUBSCRIPTION_PLAN_DETAILS%%

You will need to log in to your dashboard to accept and activate this subscription.

%%LOGIN%%

Best Regards

%%CURRENT_USER%%

%%COMPANY_NAME%%
Tel: %%COMPANY_TELEPHONE%%
Email: %%COMPANY_SALES_EMAIL%%';			
			update_option('cqpim_new_subscription_content', $text);			
			update_option('cqpim_new_subscription_accept_subject', '%%CURRENT_USER%% has activated Subscription %%SUBSCRIPTION_ID%%');
			$text = 'Dear %%TEAM_NAME%%

%%CURRENT_USER%% has activated subscription %%SUBSCRIPTION_ID%%

%%SUBSCRIPTION_PLAN_DETAILS%%

You can view details by logging in to your dashboard.

%%LOGIN%%

Best Regards

%%COMPANY_NAME%%
Tel: %%COMPANY_TELEPHONE%%
Email: %%COMPANY_SALES_EMAIL%%';			
			update_option('cqpim_new_subscription_accept_content', $text);
			update_option('cqpim_subscription_cancelled_subject', 'Subscription %%SUBSCRIPTION_ID%% has been cancelled');
			$text = 'Dear %%NAME%%

This email confirms that subscription %%SUBSCRIPTION_ID%% has been cancelled. You will not be billed further for this subscription.

%%SUBSCRIPTION_PLAN_DETAILS%%

If you would like to reactivate this subscription, please log in to your account and click the "Reactivate Subscription" button.

%%LOGIN%%

Best Regards

%%COMPANY_NAME%%
Tel: %%COMPANY_TELEPHONE%%
Email: %%COMPANY_SALES_EMAIL%%';			
			update_option('cqpim_subscription_cancelled_content', $text);	
			update_option('cqpim_subscription_failed_subject', 'Your Subscription Payment Failed (%%SUBSCRIPTION_ID%%)');
			$text = 'Dear %%CLIENT_NAME%%

Unfortunately the payment for subscription %%SUBSCRIPTION_ID%% could not be taken. 

%%SUBSCRIPTION_PLAN_DETAILS%%

Please log in to your account to update your payment details or contact us to discuss this subscription.

%%LOGIN%%

Best Regards

%%COMPANY_NAME%%
Tel: %%COMPANY_TELEPHONE%%
Email: %%COMPANY_SALES_EMAIL%%';		
			update_option('cqpim_subscription_failed_content', $text);	
			update_option('cqpim_subscription_reminder_subject', 'Subscription Payment Reminder (%%SUBSCRIPTION_ID%%)');
			$text = 'Dear %%CLIENT_NAME%%

This is a reminder that your payment for subscription %%SUBSCRIPTION_ID%% will be charged to your debit / credit card in %%DAYS%% days. 

%%SUBSCRIPTION_PLAN_DETAILS%%

Best Regards

%%COMPANY_NAME%%
Tel: %%COMPANY_TELEPHONE%%
Email: %%COMPANY_SALES_EMAIL%%';			
			update_option('cqpim_subscription_reminder_content', $text);			
		}
	} else {
		$message = __('You need to have the core Projectopia Plugin active to activate this Add-On', 'cqpim-subscriptions');
		wp_die($message, 'Projectopia Core Plugin Missing');
	}
}
// Includes
require_once( 'subscriptions.php' );
require_once( 'cpt/subscriptions.php' );
require_once( 'cpt/plans.php' );
// Metaboxes
require_once('metaboxes/main.php');
require_once('functions/pto_subscriptions_twocheck_functions.php');
require_once('functions/pto_subscriptions_stripe_functions.php');
require_once('functions/pto_subscriptions_paypal_functions.php');
require_once('functions/pto_subscriptions_functions.php');
require_once('functions/pto_subscriptions_cd_functions.php');