<?php
add_action( 'admin_menu' , 'register_pto_subscriptions_page', 27 ); 
function register_pto_subscriptions_page() {
	$mypage = add_submenu_page(	
				'pto-dashboard',
				__('Subscriptions Dashboard', 'cqpim-subscriptions'), 			
				__('Subscriptions Dashboard', 'cqpim-subscriptions'),  			
				'view_cqpim_subscriptions', 			
				'pto-subscriptions', 		
				'pto_subscriptions'
	);
	add_action( 'load-' . $mypage, 'pto_enqueue_plugin_option_scripts' );
}
function pto_subscriptions() { ?>
	<div class="masonry-grid">
		<div class="grid-sizer"></div>
		<div class="cqpim-dash-item-full grid-item">
			<a class="cqpim_button bg-blue-madison cqpim_button_link font-white rounded_2 sbold block op" href="<?php echo admin_url(); ?>post-new.php?post_type=cqpim_subscription"><?php _e('Add Subscription', 'cqpim-subscriptions') ?></a>		
			<br />
		</div>
		<div class="cqpim-dash-item-triple grid-item">
			<?php $selected = isset($_SESSION['renewals_in']) ? $_SESSION['renewals_in'] : 30; ?>
			<div class="cqpim_block">
				<div class="cqpim_block_title">
					<div class="caption">
						<span class="caption-subject font-green-sharp sbold"><?php printf(__('Subscriptions due within %1$s days', 'cqpim-subscriptions'), $selected); ?> </span>
					</div>
					<div class="actions">
						<div class="income_controls">
							<select id="sub_renewals_in">
								<option value="30" <?php selected($selected, 30); ?>><?php _e('30 days', 'cqpim-subscriptions'); ?></option>
								<option value="60" <?php selected($selected, 60); ?>><?php _e('60 days', 'cqpim-subscriptions'); ?></option>
								<option value="90" <?php selected($selected, 90); ?>><?php _e('90 days', 'cqpim-subscriptions'); ?></option>
							</select>
						</div>
					</div>
				</div>
				<div class="cqpim-dash-item-inside">
					<?php
					$now = current_time('timestamp');
					$compare = strtotime('+' . $selected . ' days', $now);
					$args = array(
						'post_type' => 'cqpim_subscription',
						'posts_per_page' => -1,
						'post_status' => 'private',
						'meta_query' => array(
							array(
								'key' => 'next_charge',
								'value' => $compare,
								'compare' => '<='
							)
						),
					);
					$subscriptions = get_posts($args);
					if(!empty($subscriptions)) { ?>
						<table class="dataTable datatable_style" data-ordering='[[0, "desc"]]'>
							<thead>
								<tr>
									<th><?php _e('ID', 'cqpim-subscriptions'); ?></th>
									<th><?php _e('Owner', 'cqpim-subscriptions'); ?></th>
									<th><?php _e('Title', 'cqpim-subscriptions'); ?></th>
									<th><?php _e('Next Charge', 'cqpim-subscriptions'); ?></th>
									<th><?php _e('Status', 'cqpim-subscriptions'); ?></th>
								</tr>
							</thead>
							<tbody>
								<?php foreach($subscriptions as $sub) {
									$subscription_id = get_post_meta($sub->ID, 'subscription_id', true);
									$subscription_status = get_post_meta($sub->ID, 'subscription_status', true);
									$last_charge = get_post_meta($sub->ID, 'last_charge', true);
									$next_charge = get_post_meta($sub->ID, 'next_charge', true);
									$subscription_client_contact = get_post_meta($sub->ID, 'subscription_client_contact', true);
									$owner = get_user_by('id', $subscription_client_contact);
									if(!empty($next_charge)) { ?>
										<tr>
											<td><a href="<?php echo get_edit_post_link($sub->ID); ?>"><?php echo $subscription_id; ?></a></td>
											<td><?php echo isset($owner->display_name) ? $owner->display_name : ''; ?></td>
											<td><a href="<?php echo get_edit_post_link($sub->ID); ?>"><?php echo $sub->post_title; ?></a></td>
											<td><?php echo !empty($next_charge) ? date(get_option('cqpim_date_format'), $next_charge) : __('N/A', 'cqpim-subscriptions'); ?> <i class="fa fa-question-circle cqpim_tooltip" aria-hidden="true" title="<?php _e('This information will be available once the subscription has been activated.', 'cqpim-subscriptions'); ?>"></i></td>
											<td><?php echo pto_return_subscription_status($subscription_status, true); ?></td>
										</tr>				
									<?php } 
									} ?>							
							</tbody>
						</table>
					<?php } else {
						echo '<p>' . __('No subscriptions found for the selected filter', 'cqpim-subscriptions') . '</p>';
					} ?>
				</div>
			</div>
		</div>
		<div class="cqpim-dash-item-double grid-item">
			<div class="cqpim_block">
				<div class="cqpim_block_title">
					<div class="caption">
						<span class="caption-subject font-green-sharp sbold"><?php _e('Failed Payments', 'cqpim-subscriptions'); ?> </span>
					</div>
					<div class="actions"></div>
				</div>
				<div class="cqpim-dash-item-inside">
					<?php 
					$args = array(
						'post_type' => 'cqpim_subscription',
						'posts_per_page' => -1,
						'post_status' => 'private',
						'meta_key' => 'subscription_status',
						'meta_value' => 'late',
					);						
					$subscriptions = get_posts($args);
					if(!empty($subscriptions)) { ?>
						<table class="dataTable datatable_style" data-ordering='[[0, "desc"]]'>
							<thead>
								<tr>
									<th><?php _e('ID', 'cqpim-subscriptions'); ?></th>
									<th><?php _e('Owner', 'cqpim-subscriptions'); ?></th>
									<th><?php _e('Next Charge', 'cqpim-subscriptions'); ?></th>
								</tr>
							</thead>
							<tbody>
								<?php foreach($subscriptions as $sub) {
									$subscription_id = get_post_meta($sub->ID, 'subscription_id', true);
									$subscription_status = get_post_meta($sub->ID, 'subscription_status', true);
									$last_charge = get_post_meta($sub->ID, 'last_charge', true);
									$next_charge = get_post_meta($sub->ID, 'next_charge', true);
									$subscription_client_contact = get_post_meta($sub->ID, 'subscription_client_contact', true);
									$owner = get_user_by('id', $subscription_client_contact);
									?>
									<tr>
										<td><a href="<?php echo get_edit_post_link($sub->ID); ?>"><?php echo $subscription_id; ?></a></td>
										<td><?php echo isset($owner->display_name) ? $owner->display_name : ''; ?></td>
										<td><?php echo !empty($next_charge) ? date(get_option('cqpim_date_format'), $next_charge) : __('N/A', 'cqpim-subscriptions'); ?> <i class="fa fa-question-circle cqpim_tooltip" aria-hidden="true" title="<?php _e('This information will be available once the subscription has been activated.', 'cqpim-subscriptions'); ?>"></i></td>
									</tr>				
								<?php } ?>							
							</tbody>
						</table>
					<?php } else {
						echo '<p>' . __('No overdue subscriptions found', 'cqpim-subscriptions') . '</p>';
					} ?>
				</div>
			</div>
		</div>
		<?php $status = isset($_SESSION['sub_status_filter']) ? $_SESSION['sub_status_filter'] : ''; ?>
		<div class="cqpim-dash-item-full grid-item">
			<div class="cqpim_block">
				<div class="cqpim_block_title">
					<div class="caption">
						<span class="caption-subject font-green-sharp sbold"><?php _e('All Subscriptions', 'cqpim-subscriptions'); ?> </span>
					</div>
					<div class="actions">
						<?php _e('Status:', 'cqpim-subscriptions') . ' '; ?>
						<select id="sub_status">
							<option value="" <?php selected($status, ''); ?>><?php _e('Any', 'cqpim-subscriptions'); ?></option>
							<option value="active" <?php selected($status, 'active'); ?>><?php _e('Active', 'cqpim-subscriptions'); ?></option>
							<option value="cancelled" <?php selected($status, 'cancelled'); ?>><?php _e('Cancelled', 'cqpim-subscriptions'); ?></option>
							<option value="inactive" <?php selected($status, 'inactive'); ?>><?php _e('Inactive', 'cqpim-subscriptions'); ?></option>
							<option value="late" <?php selected($status, 'late'); ?>><?php _e('Overdue', 'cqpim-subscriptions'); ?></option>
							<option value="expired" <?php selected($status, 'expired'); ?>><?php _e('Expired', 'cqpim-subscriptions'); ?></option>
						</select>				
					</div>
				</div>
				<div class="cqpim-dash-item-inside">
					<?php 
					if(empty($status)) {
						$args = array(
							'post_type' => 'cqpim_subscription',
							'posts_per_page' => -1,
							'post_status' => 'private'
						); 
					} else {
						$args = array(
							'post_type' => 'cqpim_subscription',
							'posts_per_page' => -1,
							'post_status' => 'private',
							'meta_key' => 'subscription_status',
							'meta_value' => $status,
						);						
					}
					$subscriptions = get_posts($args);
					if(!empty($subscriptions)) { ?>
						<table class="dataTable datatable_style" data-ordering='[[0, "desc"]]'>
							<thead>
								<tr>
									<th><?php _e('ID', 'cqpim-subscriptions'); ?></th>
									<th><?php _e('Owner', 'cqpim-subscriptions'); ?></th>
									<th><?php _e('Title', 'cqpim-subscriptions'); ?></th>
									<th><?php _e('Last Charge', 'cqpim-subscriptions'); ?></th>
									<th><?php _e('Next Charge', 'cqpim-subscriptions'); ?></th>
									<th><?php _e('Status', 'cqpim-subscriptions'); ?></th>
								</tr>
							</thead>
							<tbody>
								<?php foreach($subscriptions as $sub) {
									$subscription_id = get_post_meta($sub->ID, 'subscription_id', true);
									$subscription_status = get_post_meta($sub->ID, 'subscription_status', true);
									$last_charge = get_post_meta($sub->ID, 'last_charge', true);
									$next_charge = get_post_meta($sub->ID, 'next_charge', true);
									$subscription_client_contact = get_post_meta($sub->ID, 'subscription_client_contact', true);
									$owner = get_user_by('id', $subscription_client_contact);
									?>
									<tr>
										<td><a href="<?php echo get_edit_post_link($sub->ID); ?>"><?php echo $subscription_id; ?></a></td>
										<td><?php echo isset($owner->display_name) ? $owner->display_name : ''; ?></td>
										<td><a href="<?php echo get_edit_post_link($sub->ID); ?>"><?php echo $sub->post_title; ?></a></td>
										<td><?php echo !empty($last_charge) ? date(get_option('cqpim_date_format'), $last_charge) : __('N/A', 'cqpim-subscriptions'); ?> <i class="fa fa-question-circle cqpim_tooltip" aria-hidden="true" title="<?php _e('This information will be available once the subscription has been activated.', 'cqpim-subscriptions'); ?>"></i></td>
										<td><?php echo !empty($next_charge) ? date(get_option('cqpim_date_format'), $next_charge) : __('N/A', 'cqpim-subscriptions'); ?> <i class="fa fa-question-circle cqpim_tooltip" aria-hidden="true" title="<?php _e('This information will be available once the subscription has been activated.', 'cqpim-subscriptions'); ?>"></i></td>
										<td><?php echo pto_return_subscription_status($subscription_status, true); ?></td>
									</tr>				
								<?php } ?>							
							</tbody>
						</table>
					<?php } else {
						echo '<p>' . __('No subscriptions found for the selected filter', 'cqpim-subscriptions') . '</p>';
					} ?>
				</div>
			</div>
		</div>
	</div>	
<?php } ?>